
_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;minisub_main.c,75 :: 		void main() {
;minisub_main.c,76 :: 		TRISA = 0x0FFF;        // Bits 13-15 are outputs
	PUSH	W10
	MOV	#4095, W0
	MOV	WREG, TRISA
;minisub_main.c,77 :: 		TRISD = 0xFFFF;        // Initialize PORTD as input
	MOV	#65535, W0
	MOV	WREG, TRISD
;minisub_main.c,78 :: 		TRISB = 0x0000;        // Initialize PORTB as output
	CLR	TRISB
;minisub_main.c,79 :: 		TRISE = 0x000;
	CLR	TRISE
;minisub_main.c,82 :: 		TRISF.B1 = 1;
	BSET	TRISF, #1
;minisub_main.c,84 :: 		LATB  = 0xFF00;       //All leds off
	MOV	#65280, W0
	MOV	WREG, LATB
;minisub_main.c,87 :: 		Init_MCU();
	CALL	_Init_MCU
;minisub_main.c,90 :: 		file_loaded = 0;
	MOV	#lo_addr(_file_loaded), W1
	CLR	W0
	MOV.B	W0, [W1]
;minisub_main.c,91 :: 		Init_Sound();
	CALL	_Init_Sound
;minisub_main.c,92 :: 		MP3_Init();
	CALL	_MP3_Init
;minisub_main.c,95 :: 		UART2_Write_Line("Mini-Sub Game Started");
	MOV	#lo_addr(?lstr1_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,96 :: 		LATB  = 0x0000;      //All leds on
	CLR	LATB
;minisub_main.c,100 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,103 :: 		GetNextSong();
	CALL	_GetNextSong
;minisub_main.c,106 :: 		while(1){
L_main0:
;minisub_main.c,109 :: 		ResetGame();
	CALL	_ResetGame
;minisub_main.c,112 :: 		ShowTitles();
	CALL	_ShowTitles
;minisub_main.c,115 :: 		ShowHelp();
	CALL	_ShowHelp
;minisub_main.c,118 :: 		while(subLives){
L_main2:
	MOV	#lo_addr(_subLives), W0
	CP0	[W0]
	BRA NZ	L__main276
	GOTO	L_main3
L__main276:
;minisub_main.c,121 :: 		InitSprites();
	CALL	_InitSprites
;minisub_main.c,124 :: 		while (mineHit == 0) {
L_main4:
	MOV	_mineHit, W0
	CP	W0, #0
	BRA Z	L__main277
	GOTO	L_main5
L__main277:
;minisub_main.c,127 :: 		GetInput();
	CALL	_GetInput
;minisub_main.c,131 :: 		if(play_next_song){
	MOV	#lo_addr(_play_next_song), W0
	CP0	[W0]
	BRA NZ	L__main278
	GOTO	L_main6
L__main278:
;minisub_main.c,133 :: 		GetNextSong();
	CALL	_GetNextSong
;minisub_main.c,134 :: 		}
	GOTO	L_main7
L_main6:
;minisub_main.c,137 :: 		Play_MP3_Chunk();
	CALL	_Play_MP3_Chunk
;minisub_main.c,138 :: 		}
L_main7:
;minisub_main.c,141 :: 		RenderScreen();
	CALL	_RenderScreen
;minisub_main.c,144 :: 		SavePreviousVal();
	CALL	_SavePreviousVal
;minisub_main.c,147 :: 		frame_counter++;
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_frame_counter), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;minisub_main.c,149 :: 		} //End of the current sub life
	GOTO	L_main4
L_main5:
;minisub_main.c,152 :: 		mineHit = 0;
	CLR	W0
	MOV	W0, _mineHit
;minisub_main.c,155 :: 		mineExplode = 0;
	CLR	W0
	MOV	W0, _mineExplode
;minisub_main.c,158 :: 		subLives--;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	SUBR	W1, [W0], [W0]
;minisub_main.c,159 :: 		}
	GOTO	L_main2
L_main3:
;minisub_main.c,162 :: 		ShowGameOver();
	CALL	_ShowGameOver
;minisub_main.c,163 :: 		}
	GOTO	L_main0
;minisub_main.c,165 :: 		}
L_end_main:
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main

_ShowNextLevel:

;minisub_main.c,170 :: 		void ShowNextLevel(){
;minisub_main.c,171 :: 		int loop = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,174 :: 		if (prev_level != level){
	MOV	_prev_level, W1
	MOV	#lo_addr(_level), W0
	CP	W1, [W0]
	BRA NZ	L__ShowNextLevel281
	GOTO	L_ShowNextLevel8
L__ShowNextLevel281:
;minisub_main.c,177 :: 		UART2_Write_Line("Next Level: ");
	MOV	#lo_addr(?lstr2_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,178 :: 		UART2_Write_Variable(level);
	MOV	_level, W10
	CALL	_UART2_Write_Variable
;minisub_main.c,179 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,180 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,183 :: 		UART2_Write_Line("Score: ");
	MOV	#lo_addr(?lstr3_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,184 :: 		UART2_Write_Variable(score);
	MOV	_score, W10
	CALL	_UART2_Write_Variable
;minisub_main.c,185 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,186 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,189 :: 		UART2_Write_Line("Mine Speed: ");
	MOV	#lo_addr(?lstr4_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,190 :: 		UART2_Write_Variable(mine_speed);
	MOV	_mine_speed, W10
	CALL	_UART2_Write_Variable
;minisub_main.c,191 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,192 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,195 :: 		UART2_Write_Line("Bonus distance factor: ");
	MOV	#lo_addr(?lstr5_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,196 :: 		UART2_Write_Variable(bonus_factor);
	MOV	_bonus_factor, W10
	CALL	_UART2_Write_Variable
;minisub_main.c,197 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,198 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,201 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,204 :: 		TFT_Image(35, (SCREEN_HEIGHT/2)-47, title_bmp, 1);
	MOV	#lo_addr(_title_bmp), W0
	MOV	#higher_addr(_title_bmp), W1
	MOV.D	W0, W12
	MOV	#73, W11
	MOV	#35, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,207 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;minisub_main.c,210 :: 		IntToStr(level, level_text);
	MOV	#lo_addr(_level_text), W11
	MOV	_level, W10
	CALL	_IntToStr
;minisub_main.c,211 :: 		strcpy(level_display_text, "Level: ");
	MOV	#lo_addr(?lstr6_minisub_main), W11
	MOV	#lo_addr(_level_display_text), W10
	CALL	_strcpy
;minisub_main.c,212 :: 		strcat(level_display_text, level_text);
	MOV	#lo_addr(_level_text), W11
	MOV	#lo_addr(_level_display_text), W10
	CALL	_strcat
;minisub_main.c,215 :: 		TFT_Write_Text(level_display_text, 140, 150);
	MOV	#150, W12
	MOV	#140, W11
	MOV	#lo_addr(_level_display_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,218 :: 		TFT_Write_Text("You  Earned  an  Extra  Life!", 80, 180);
	MOV	#180, W12
	MOV	#80, W11
	MOV	#lo_addr(?lstr7_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,222 :: 		for(loop = 0; loop<=60;loop++){
; loop start address is: 2 (W1)
	CLR	W1
; loop end address is: 2 (W1)
L_ShowNextLevel9:
; loop start address is: 2 (W1)
	MOV	#60, W0
	CP	W1, W0
	BRA LE	L__ShowNextLevel282
	GOTO	L_ShowNextLevel10
L__ShowNextLevel282:
;minisub_main.c,223 :: 		Play_MP3_Chunk();
	PUSH	W1
	CALL	_Play_MP3_Chunk
	POP	W1
;minisub_main.c,224 :: 		Delay_ms(50);
	MOV	#9, W8
	MOV	#9047, W7
L_ShowNextLevel12:
	DEC	W7
	BRA NZ	L_ShowNextLevel12
	DEC	W8
	BRA NZ	L_ShowNextLevel12
;minisub_main.c,222 :: 		for(loop = 0; loop<=60;loop++){
	INC	W1
;minisub_main.c,225 :: 		}
; loop end address is: 2 (W1)
	GOTO	L_ShowNextLevel9
L_ShowNextLevel10:
;minisub_main.c,229 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,232 :: 		InitSprites();
	CALL	_InitSprites
;minisub_main.c,233 :: 		}
L_ShowNextLevel8:
;minisub_main.c,236 :: 		}
L_end_ShowNextLevel:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ShowNextLevel

_ShowGameOver:

;minisub_main.c,244 :: 		void ShowGameOver(){
;minisub_main.c,245 :: 		int loop = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,247 :: 		UART2_Write_Line("Game Over");
	MOV	#lo_addr(?lstr8_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,250 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,253 :: 		TFT_Image(0, (SCREEN_HEIGHT/2)-47, GameOver_bmp, 1);
	MOV	#lo_addr(_gameover_bmp), W0
	MOV	#higher_addr(_gameover_bmp), W1
	MOV.D	W0, W12
	MOV	#73, W11
	CLR	W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,256 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;minisub_main.c,260 :: 		if(score > high_score){
	MOV	_score, W1
	MOV	#lo_addr(_high_score), W0
	CP	W1, [W0]
	BRA GTU	L__ShowGameOver284
	GOTO	L_ShowGameOver14
L__ShowGameOver284:
;minisub_main.c,262 :: 		high_score = score;
	MOV	_score, W0
	MOV	W0, _high_score
;minisub_main.c,263 :: 		TFT_Write_Text("You  set  a  High  Score!", 95, 140);
	MOV	#140, W12
	MOV	#95, W11
	MOV	#lo_addr(?lstr9_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,264 :: 		}
	GOTO	L_ShowGameOver15
L_ShowGameOver14:
;minisub_main.c,269 :: 		IntToStr(high_score, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	_high_score, W10
	CALL	_IntToStr
;minisub_main.c,270 :: 		strcpy(score_display_text, "High  Score: ");
	MOV	#lo_addr(?lstr10_minisub_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;minisub_main.c,271 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;minisub_main.c,274 :: 		TFT_Write_Text(score_display_text, 110, 140);
	MOV	#140, W12
	MOV	#110, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,275 :: 		}
L_ShowGameOver15:
;minisub_main.c,278 :: 		IntToStr(score, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	_score, W10
	CALL	_IntToStr
;minisub_main.c,279 :: 		strcpy(score_display_text, "Your  Score: ");
	MOV	#lo_addr(?lstr11_minisub_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;minisub_main.c,280 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;minisub_main.c,283 :: 		TFT_Write_Text(score_display_text, 110, 170);
	MOV	#170, W12
	MOV	#110, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,286 :: 		for(loop = 0; loop<=60;loop++){
; loop start address is: 2 (W1)
	CLR	W1
; loop end address is: 2 (W1)
L_ShowGameOver16:
; loop start address is: 2 (W1)
	MOV	#60, W0
	CP	W1, W0
	BRA LE	L__ShowGameOver285
	GOTO	L_ShowGameOver17
L__ShowGameOver285:
;minisub_main.c,287 :: 		Play_MP3_Chunk();
	PUSH	W1
	CALL	_Play_MP3_Chunk
	POP	W1
;minisub_main.c,288 :: 		Delay_ms(50);
	MOV	#9, W8
	MOV	#9047, W7
L_ShowGameOver19:
	DEC	W7
	BRA NZ	L_ShowGameOver19
	DEC	W8
	BRA NZ	L_ShowGameOver19
;minisub_main.c,286 :: 		for(loop = 0; loop<=60;loop++){
	INC	W1
;minisub_main.c,289 :: 		}
; loop end address is: 2 (W1)
	GOTO	L_ShowGameOver16
L_ShowGameOver17:
;minisub_main.c,293 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,294 :: 		}
L_end_ShowGameOver:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ShowGameOver

_ShowTitles:
	LNK	#2

;minisub_main.c,298 :: 		void ShowTitles(){
;minisub_main.c,299 :: 		int step_value = 10;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	#10, W0
	MOV	W0, [W14+0]
;minisub_main.c,302 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,305 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,308 :: 		TFT_Image(35, (SCREEN_HEIGHT/2)-47, title_bmp, 1);
	MOV	#lo_addr(_title_bmp), W0
	MOV	#higher_addr(_title_bmp), W1
	MOV.D	W0, W12
	MOV	#73, W11
	MOV	#35, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,312 :: 		TFT_Write_Text("Press the Start button to play.", 75, 220);
	MOV	#220, W12
	MOV	#75, W11
	MOV	#lo_addr(?lstr12_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,315 :: 		sub.y = 160;
	MOV	#160, W0
	MOV	W0, _sub+2
;minisub_main.c,318 :: 		for(sub.x = step_value+1;(sub.x <= (SCREEN_WIDTH+1)) && (!startButton);sub.x+=step_value){
	MOV	[W14+0], W0
	INC	W0
	MOV	W0, _sub
L_ShowTitles21:
	MOV	_sub, W1
	MOV	#321, W0
	CP	W1, W0
	BRA LE	L__ShowTitles287
	GOTO	L__ShowTitles216
L__ShowTitles287:
	BTSC	PORTF, #1
	GOTO	L__ShowTitles215
L__ShowTitles214:
;minisub_main.c,321 :: 		TFT_Image(sub.x, sub.y, sub_bmp, 1);
	MOV	#lo_addr(_sub_bmp), W0
	MOV	#higher_addr(_sub_bmp), W1
	MOV.D	W0, W12
	MOV	_sub+2, W11
	MOV	_sub, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,324 :: 		Play_MP3_Chunk();
	CALL	_Play_MP3_Chunk
;minisub_main.c,328 :: 		TFT_Rectangle(sub.x-step_value, sub.y, sub.x+step_value, sub.y + PLAYER_HEIGHT );
	MOV	#47, W1
	MOV	#lo_addr(_sub+2), W0
	ADD	W1, [W0], W3
	MOV	_sub, W1
	ADD	W14, #0, W0
	ADD	W1, [W0], W2
	MOV	_sub, W1
	ADD	W14, #0, W0
	SUB	W1, [W0], W0
	MOV	W3, W13
	MOV	W2, W12
	MOV	_sub+2, W11
	MOV	W0, W10
	CALL	_TFT_Rectangle
;minisub_main.c,331 :: 		frame_counter++;
	MOV	#1, W1
	MOV	#0, W2
	MOV	#lo_addr(_frame_counter), W0
	ADD	W1, [W0], [W0++]
	ADDC	W2, [W0], [W0--]
;minisub_main.c,334 :: 		if(startButton){
	BTSS	PORTF, #1
	GOTO	L_ShowTitles26
;minisub_main.c,335 :: 		start_game_flag = 1;
	MOV	#1, W0
	MOV	W0, _start_game_flag
;minisub_main.c,336 :: 		}
L_ShowTitles26:
;minisub_main.c,318 :: 		for(sub.x = step_value+1;(sub.x <= (SCREEN_WIDTH+1)) && (!startButton);sub.x+=step_value){
	MOV	_sub, W1
	ADD	W14, #0, W0
	ADD	W1, [W0], W0
	MOV	W0, _sub
;minisub_main.c,338 :: 		}
	GOTO	L_ShowTitles21
;minisub_main.c,318 :: 		for(sub.x = step_value+1;(sub.x <= (SCREEN_WIDTH+1)) && (!startButton);sub.x+=step_value){
L__ShowTitles216:
L__ShowTitles215:
;minisub_main.c,341 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,342 :: 		}
L_end_ShowTitles:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _ShowTitles

_ShowHelp:

;minisub_main.c,346 :: 		void ShowHelp(){
;minisub_main.c,347 :: 		int loop = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,348 :: 		UART2_Write_Line("Help Screens");
	MOV	#lo_addr(?lstr13_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,351 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,355 :: 		if(!start_game_flag){
	MOV	#lo_addr(_start_game_flag), W0
	CP0	[W0]
	BRA Z	L__ShowHelp289
	GOTO	L_ShowHelp27
L__ShowHelp289:
;minisub_main.c,358 :: 		TFT_Write_Text("Overview", 132, 8);
	MOV	#8, W12
	MOV	#132, W11
	MOV	#lo_addr(?lstr14_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,361 :: 		TFT_Image(8, 46, sub_bmp, 1);   //8, 43
	MOV	#lo_addr(_sub_bmp), W0
	MOV	#higher_addr(_sub_bmp), W1
	MOV.D	W0, W12
	MOV	#46, W11
	MOV	#8, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,363 :: 		TFT_Write_Text("Navigate  your  sub  through  an", 86, 48);
	MOV	#48, W12
	MOV	#86, W11
	MOV	#lo_addr(?lstr15_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,364 :: 		TFT_Write_Text("ocean  filled  with  dangerous  sea", 86, 64);
	MOV	#64, W12
	MOV	#86, W11
	MOV	#lo_addr(?lstr16_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,365 :: 		TFT_Write_Text("mines  while  collecting  points.", 86, 80);
	MOV	#80, W12
	MOV	#86, W11
	MOV	#lo_addr(?lstr17_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,368 :: 		TFT_Write_Text("Pickup  bonus  items  as  you  go:", 17, 115); //96
	MOV	#115, W12
	MOV	#17, W11
	MOV	#lo_addr(?lstr18_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,371 :: 		TFT_Image(18, 137, torpedo_pack_bmp, 1);
	MOV	#lo_addr(_torpedo_pack_bmp), W0
	MOV	#higher_addr(_torpedo_pack_bmp), W1
	MOV.D	W0, W12
	MOV	#137, W11
	MOV	#18, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,372 :: 		TFT_Write_Text("Pickup  3  extra  torpedoes.", 86, 151);    //130
	MOV	#151, W12
	MOV	#86, W11
	MOV	#lo_addr(?lstr19_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,375 :: 		TFT_Image(17, 188, heart_pack_bmp, 1);
	MOV	#lo_addr(_heart_pack_bmp), W0
	MOV	#higher_addr(_heart_pack_bmp), W1
	MOV.D	W0, W12
	MOV	#188, W11
	MOV	#17, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,376 :: 		TFT_Write_Text("Pickup  an  extra  life.", 86, 202);  //194
	MOV	#202, W12
	MOV	#86, W11
	MOV	#lo_addr(?lstr20_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,379 :: 		for(loop = 0; (loop<=100) && (!start_game_flag);loop++){
; loop start address is: 2 (W1)
	CLR	W1
; loop end address is: 2 (W1)
L_ShowHelp28:
; loop start address is: 2 (W1)
	MOV	#100, W0
	CP	W1, W0
	BRA LE	L__ShowHelp290
	GOTO	L__ShowHelp221
L__ShowHelp290:
	MOV	#lo_addr(_start_game_flag), W0
	CP0	[W0]
	BRA Z	L__ShowHelp291
	GOTO	L__ShowHelp220
L__ShowHelp291:
L__ShowHelp219:
;minisub_main.c,380 :: 		Play_MP3_Chunk();
	PUSH	W1
	CALL	_Play_MP3_Chunk
	POP	W1
;minisub_main.c,381 :: 		Delay_ms(50);
	MOV	#9, W8
	MOV	#9047, W7
L_ShowHelp33:
	DEC	W7
	BRA NZ	L_ShowHelp33
	DEC	W8
	BRA NZ	L_ShowHelp33
;minisub_main.c,385 :: 		if(startButton){
	BTSS	PORTF, #1
	GOTO	L_ShowHelp35
;minisub_main.c,386 :: 		start_game_flag = 1;
	MOV	#1, W0
	MOV	W0, _start_game_flag
;minisub_main.c,387 :: 		}
L_ShowHelp35:
;minisub_main.c,379 :: 		for(loop = 0; (loop<=100) && (!start_game_flag);loop++){
	INC	W1
;minisub_main.c,388 :: 		}
; loop end address is: 2 (W1)
	GOTO	L_ShowHelp28
;minisub_main.c,379 :: 		for(loop = 0; (loop<=100) && (!start_game_flag);loop++){
L__ShowHelp221:
L__ShowHelp220:
;minisub_main.c,390 :: 		}
L_ShowHelp27:
;minisub_main.c,392 :: 		if(!start_game_flag){
	MOV	#lo_addr(_start_game_flag), W0
	CP0	[W0]
	BRA Z	L__ShowHelp292
	GOTO	L_ShowHelp36
L__ShowHelp292:
;minisub_main.c,396 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,398 :: 		TFT_Write_Text("Overview", 132, 8);
	MOV	#8, W12
	MOV	#132, W11
	MOV	#lo_addr(?lstr21_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,401 :: 		TFT_Image(24, 116, sub_bmp, 1);
	MOV	#lo_addr(_sub_bmp), W0
	MOV	#higher_addr(_sub_bmp), W1
	MOV.D	W0, W12
	MOV	#116, W11
	MOV	#24, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,404 :: 		TFT_Image(102, 132, torpedo_bmp, 1);
	MOV	#lo_addr(_torpedo_bmp), W0
	MOV	#higher_addr(_torpedo_bmp), W1
	MOV.D	W0, W12
	MOV	#132, W11
	MOV	#102, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,407 :: 		TFT_Image(187, 117, mine1_bmp, 1);
	MOV	#lo_addr(_mine1_bmp), W0
	MOV	#higher_addr(_mine1_bmp), W1
	MOV.D	W0, W12
	MOV	#117, W11
	MOV	#187, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,408 :: 		TFT_Image(248, 56, mine2_bmp, 1);
	MOV	#lo_addr(_mine2_bmp), W0
	MOV	#higher_addr(_mine2_bmp), W1
	MOV.D	W0, W12
	MOV	#56, W11
	MOV	#248, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,410 :: 		TFT_Image(118, 54, dark_mine1_bmp, 1);
	MOV	#lo_addr(_dark_mine1_bmp), W0
	MOV	#higher_addr(_dark_mine1_bmp), W1
	MOV.D	W0, W12
	MOV	#54, W11
	MOV	#118, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,412 :: 		TFT_Write_Text("Press  the  square  button  to  fire your torpedoes.", 5, 175);//191
	MOV	#175, W12
	MOV	#5, W11
	MOV	#lo_addr(?lstr22_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,413 :: 		TFT_Write_Text("Red  sea  mines  take  1  torpedo  hit.", 40, 200);
	MOV	#200, W12
	MOV	#40, W11
	MOV	#lo_addr(?lstr23_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,414 :: 		TFT_Write_Text("Grey  sea  mines  take  2  torpedo  hits.", 40, 216);
	MOV	#216, W12
	MOV	#40, W11
	MOV	#lo_addr(?lstr24_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,417 :: 		for(loop = 0; (loop<=100) && (!start_game_flag);loop++){
; loop start address is: 2 (W1)
	CLR	W1
; loop end address is: 2 (W1)
L_ShowHelp37:
; loop start address is: 2 (W1)
	MOV	#100, W0
	CP	W1, W0
	BRA LE	L__ShowHelp293
	GOTO	L__ShowHelp223
L__ShowHelp293:
	MOV	#lo_addr(_start_game_flag), W0
	CP0	[W0]
	BRA Z	L__ShowHelp294
	GOTO	L__ShowHelp222
L__ShowHelp294:
L__ShowHelp218:
;minisub_main.c,418 :: 		Play_MP3_Chunk();
	PUSH	W1
	CALL	_Play_MP3_Chunk
	POP	W1
;minisub_main.c,419 :: 		Delay_ms(50);
	MOV	#9, W8
	MOV	#9047, W7
L_ShowHelp42:
	DEC	W7
	BRA NZ	L_ShowHelp42
	DEC	W8
	BRA NZ	L_ShowHelp42
;minisub_main.c,422 :: 		if(startButton){
	BTSS	PORTF, #1
	GOTO	L_ShowHelp44
;minisub_main.c,423 :: 		start_game_flag = 1;
	MOV	#1, W0
	MOV	W0, _start_game_flag
;minisub_main.c,424 :: 		}
L_ShowHelp44:
;minisub_main.c,417 :: 		for(loop = 0; (loop<=100) && (!start_game_flag);loop++){
	INC	W1
;minisub_main.c,426 :: 		}
; loop end address is: 2 (W1)
	GOTO	L_ShowHelp37
;minisub_main.c,417 :: 		for(loop = 0; (loop<=100) && (!start_game_flag);loop++){
L__ShowHelp223:
L__ShowHelp222:
;minisub_main.c,428 :: 		}
L_ShowHelp36:
;minisub_main.c,430 :: 		if(!start_game_flag){
	MOV	#lo_addr(_start_game_flag), W0
	CP0	[W0]
	BRA Z	L__ShowHelp295
	GOTO	L_ShowHelp45
L__ShowHelp295:
;minisub_main.c,434 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,436 :: 		TFT_Write_Text("Credits", 132, 8);
	MOV	#8, W12
	MOV	#132, W11
	MOV	#lo_addr(?lstr25_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,439 :: 		TFT_Image(28, 36,  andrew_bmp, 1);
	MOV	#lo_addr(_andrew_bmp), W0
	MOV	#higher_addr(_andrew_bmp), W1
	MOV.D	W0, W12
	MOV	#36, W11
	MOV	#28, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,440 :: 		TFT_Image(28, 109, tonyB_bmp, 1);
	MOV	#lo_addr(_tonyB_bmp), W0
	MOV	#higher_addr(_tonyB_bmp), W1
	MOV.D	W0, W12
	MOV	#109, W11
	MOV	#28, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,441 :: 		TFT_Image(28, 178, mikroe_bmp, 1);
	MOV	#lo_addr(_mikroe_bmp), W0
	MOV	#higher_addr(_mikroe_bmp), W1
	MOV.D	W0, W12
	MOV	#178, W11
	MOV	#28, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,446 :: 		TFT_Write_Text("Game   by   Andrew   Hazelden", 82, 44);
	MOV	#44, W12
	MOV	#82, W11
	MOV	#lo_addr(?lstr26_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,448 :: 		TFT_Write_Text("Music   by   Tony   B   Machine", 82, 117);
	MOV	#117, W12
	MOV	#82, W11
	MOV	#lo_addr(?lstr27_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,450 :: 		TFT_Write_Text("Developed   using   MikroElektronika's", 82, 178);
	MOV	#178, W12
	MOV	#82, W11
	MOV	#lo_addr(?lstr28_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,451 :: 		TFT_Write_Text("MikroC   Pro   for   dsPIC   compiler.", 82, 194); //195
	MOV	#194, W12
	MOV	#82, W11
	MOV	#lo_addr(?lstr29_minisub_main), W10
	CALL	_TFT_Write_Text
;minisub_main.c,455 :: 		for(loop = 0; (loop<=60) && (!start_game_flag);loop++){
; loop start address is: 2 (W1)
	CLR	W1
; loop end address is: 2 (W1)
L_ShowHelp46:
; loop start address is: 2 (W1)
	MOV	#60, W0
	CP	W1, W0
	BRA LE	L__ShowHelp296
	GOTO	L__ShowHelp225
L__ShowHelp296:
	MOV	#lo_addr(_start_game_flag), W0
	CP0	[W0]
	BRA Z	L__ShowHelp297
	GOTO	L__ShowHelp224
L__ShowHelp297:
L__ShowHelp217:
;minisub_main.c,456 :: 		Play_MP3_Chunk();
	PUSH	W1
	CALL	_Play_MP3_Chunk
	POP	W1
;minisub_main.c,457 :: 		Delay_ms(50);
	MOV	#9, W8
	MOV	#9047, W7
L_ShowHelp51:
	DEC	W7
	BRA NZ	L_ShowHelp51
	DEC	W8
	BRA NZ	L_ShowHelp51
;minisub_main.c,460 :: 		if(startButton){
	BTSS	PORTF, #1
	GOTO	L_ShowHelp53
;minisub_main.c,461 :: 		start_game_flag = 1;
	MOV	#1, W0
	MOV	W0, _start_game_flag
;minisub_main.c,462 :: 		}
L_ShowHelp53:
;minisub_main.c,455 :: 		for(loop = 0; (loop<=60) && (!start_game_flag);loop++){
	INC	W1
;minisub_main.c,464 :: 		}
; loop end address is: 2 (W1)
	GOTO	L_ShowHelp46
;minisub_main.c,455 :: 		for(loop = 0; (loop<=60) && (!start_game_flag);loop++){
L__ShowHelp225:
L__ShowHelp224:
;minisub_main.c,466 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,468 :: 		}
L_ShowHelp45:
;minisub_main.c,471 :: 		}
L_end_ShowHelp:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ShowHelp

_GetInput:

;minisub_main.c,473 :: 		void GetInput()  {
;minisub_main.c,474 :: 		int mine_inc = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,475 :: 		int edge_border = 3;
; edge_border start address is: 12 (W6)
	MOV	#3, W6
;minisub_main.c,478 :: 		LED1 = 1;
	BSET	PORTA, #13
;minisub_main.c,480 :: 		if(startButton){
	BTSS	PORTF, #1
	GOTO	L_GetInput54
;minisub_main.c,484 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,485 :: 		}
L_GetInput54:
;minisub_main.c,487 :: 		if(upButton) {
	BTSS	PORTD, #14
	GOTO	L_GetInput55
;minisub_main.c,488 :: 		sub.y -= SUB_Y_SPEED;
	MOV	_sub+2, W0
	SUB	W0, #8, W0
	MOV	W0, _sub+2
;minisub_main.c,492 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,493 :: 		}
	GOTO	L_GetInput56
L_GetInput55:
;minisub_main.c,494 :: 		else if(downButton){
	BTSS	PORTD, #15
	GOTO	L_GetInput57
;minisub_main.c,495 :: 		sub.y += SUB_Y_SPEED;
	MOV	_sub+2, W0
	ADD	W0, #8, W0
	MOV	W0, _sub+2
;minisub_main.c,499 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,500 :: 		}
	GOTO	L_GetInput58
L_GetInput57:
;minisub_main.c,501 :: 		else if(leftButton) {
	BTSS	PORTD, #9
	GOTO	L_GetInput59
;minisub_main.c,502 :: 		sub.x -= SUB_SPEED;
	MOV	_sub, W0
	SUB	W0, #12, W0
	MOV	W0, _sub
;minisub_main.c,506 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,507 :: 		}
	GOTO	L_GetInput60
L_GetInput59:
;minisub_main.c,508 :: 		else if(rightButton){
	BTSS	PORTD, #6
	GOTO	L_GetInput61
;minisub_main.c,509 :: 		sub.x += SUB_SPEED;
	MOV	_sub, W0
	ADD	W0, #12, W0
	MOV	W0, _sub
;minisub_main.c,513 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,514 :: 		}
	GOTO	L_GetInput62
L_GetInput61:
;minisub_main.c,518 :: 		if( (frame_counter % 2) == 0){
	MOV	_frame_counter, W0
	MOV	_frame_counter+2, W1
	AND	W0, #1, W0
	AND	W1, #0, W1
	CP	W0, #0
	CPB	W1, #0
	BRA Z	L__GetInput299
	GOTO	L_GetInput63
L__GetInput299:
;minisub_main.c,520 :: 		if(sub.x > DEFAULT_SUB_X_POS){
	MOV	_sub, W0
	CP	W0, #28
	BRA GT	L__GetInput300
	GOTO	L_GetInput64
L__GetInput300:
;minisub_main.c,521 :: 		sub.x -= 1;
	MOV	_sub, W0
	DEC	W0
	MOV	W0, _sub
;minisub_main.c,522 :: 		}
L_GetInput64:
;minisub_main.c,523 :: 		}
L_GetInput63:
;minisub_main.c,526 :: 		if( (frame_counter % 4) == 0){
	MOV	_frame_counter, W0
	MOV	_frame_counter+2, W1
	AND	W0, #3, W0
	AND	W1, #0, W1
	CP	W0, #0
	CPB	W1, #0
	BRA Z	L__GetInput301
	GOTO	L_GetInput65
L__GetInput301:
;minisub_main.c,528 :: 		if(sub.x < DEFAULT_SUB_X_POS){
	MOV	_sub, W0
	CP	W0, #28
	BRA LT	L__GetInput302
	GOTO	L_GetInput66
L__GetInput302:
;minisub_main.c,529 :: 		sub.x += 1;
	MOV	_sub, W0
	INC	W0
	MOV	W0, _sub
;minisub_main.c,530 :: 		}
L_GetInput66:
;minisub_main.c,531 :: 		}
L_GetInput65:
;minisub_main.c,533 :: 		}
L_GetInput62:
L_GetInput60:
L_GetInput58:
L_GetInput56:
;minisub_main.c,537 :: 		if( sub.y <= STATUS_TEXT_CELL_HEIGHT ){
	MOV	_sub+2, W0
	CP	W0, #25
	BRA LE	L__GetInput303
	GOTO	L_GetInput67
L__GetInput303:
;minisub_main.c,538 :: 		sub.y = STATUS_TEXT_CELL_HEIGHT;
	MOV	#25, W0
	MOV	W0, _sub+2
;minisub_main.c,539 :: 		}
L_GetInput67:
;minisub_main.c,542 :: 		if( sub.x <= 0 ){
	MOV	_sub, W0
	CP	W0, #0
	BRA LE	L__GetInput304
	GOTO	L_GetInput68
L__GetInput304:
;minisub_main.c,543 :: 		sub.x = 0;
	CLR	W0
	MOV	W0, _sub
;minisub_main.c,544 :: 		}
L_GetInput68:
;minisub_main.c,547 :: 		if( sub.y >= (SCREEN_HEIGHT-PLAYER_HEIGHT)){
	MOV	#193, W1
	MOV	#lo_addr(_sub+2), W0
	CP	W1, [W0]
	BRA LE	L__GetInput305
	GOTO	L_GetInput69
L__GetInput305:
;minisub_main.c,548 :: 		sub.y = SCREEN_HEIGHT-PLAYER_HEIGHT;
	MOV	#193, W0
	MOV	W0, _sub+2
;minisub_main.c,549 :: 		}
L_GetInput69:
;minisub_main.c,552 :: 		if( sub.x >= (SCREEN_WIDTH-PLAYER_WIDTH)){
	MOV	_sub, W1
	MOV	#257, W0
	CP	W1, W0
	BRA GE	L__GetInput306
	GOTO	L_GetInput70
L__GetInput306:
;minisub_main.c,553 :: 		sub.x = SCREEN_WIDTH-PLAYER_WIDTH;
	MOV	#257, W0
	MOV	W0, _sub
;minisub_main.c,554 :: 		}
L_GetInput70:
;minisub_main.c,557 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 14 (W7)
	CLR	W7
; edge_border end address is: 12 (W6)
; mine_inc end address is: 14 (W7)
L_GetInput71:
; mine_inc start address is: 14 (W7)
; edge_border start address is: 12 (W6)
	CP	W7, #3
	BRA LE	L__GetInput307
	GOTO	L_GetInput72
L__GetInput307:
;minisub_main.c,560 :: 		if( mine[mine_inc].x <= edge_border){
	MOV	#18, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W0
	MOV	[W0], W0
	CP	W0, W6
	BRA LE	L__GetInput308
	GOTO	L_GetInput74
L__GetInput308:
;minisub_main.c,563 :: 		ResetSeaMine(mine_inc);
	MOV	W7, W10
	CALL	_ResetSeaMine
;minisub_main.c,566 :: 		TFT_Rectangle( mine[mine_inc].prev_x-1, mine[mine_inc].prev_y-1, mine[mine_inc].prev_x + mine[mine_inc].width + 1, mine[mine_inc].prev_y + mine[mine_inc].height + 1);
	MOV	#18, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #10, W0
	MOV	[W0], W1
	ADD	W4, #2, W0
	ADD	W1, [W0], W0
	ADD	W0, #1, W5
	ADD	W4, #8, W0
	MOV	[W0], W3
	MOV	[W4], W0
	ADD	W3, W0, W0
	ADD	W0, #1, W2
	DEC	W1
	SUB	W3, #1, W0
	PUSH.D	W6
	MOV	W5, W13
	MOV	W2, W12
	MOV	W1, W11
	MOV	W0, W10
	CALL	_TFT_Rectangle
	POP.D	W6
;minisub_main.c,569 :: 		score += 25;
	MOV	#25, W1
	MOV	#lo_addr(_score), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,570 :: 		}
	GOTO	L_GetInput75
L_GetInput74:
;minisub_main.c,573 :: 		mine[mine_inc].x -= mine_speed;
	MOV	#18, W0
	MUL.UU	W0, W7, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W2
	MOV	[W2], W1
	MOV	#lo_addr(_mine_speed), W0
	SUB	W1, [W0], [W2]
;minisub_main.c,574 :: 		}
L_GetInput75:
;minisub_main.c,557 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W7
;minisub_main.c,576 :: 		}
; mine_inc end address is: 14 (W7)
	GOTO	L_GetInput71
L_GetInput72:
;minisub_main.c,579 :: 		if(bonus_block.x<=edge_border){
	MOV	#lo_addr(_bonus_block+4), W0
	CP	W6, [W0]
	BRA GE	L__GetInput309
	GOTO	L_GetInput76
L__GetInput309:
; edge_border end address is: 12 (W6)
;minisub_main.c,582 :: 		TFT_Rectangle( bonus_block.prev_x-1, bonus_block.prev_y-1, bonus_block.prev_x + bonus_block.width + 1, bonus_block.prev_y + bonus_block.height + 1);
	MOV	_bonus_block+10, W1
	MOV	#lo_addr(_bonus_block+2), W0
	ADD	W1, [W0], W0
	ADD	W0, #1, W3
	MOV	_bonus_block+8, W1
	MOV	#lo_addr(_bonus_block), W0
	ADD	W1, [W0], W0
	ADD	W0, #1, W2
	MOV	_bonus_block+10, W0
	SUB	W0, #1, W1
	MOV	_bonus_block+8, W0
	DEC	W0
	MOV	W3, W13
	MOV	W2, W12
	MOV	W1, W11
	MOV	W0, W10
	CALL	_TFT_Rectangle
;minisub_main.c,585 :: 		ResetBonusBlock();
	CALL	_ResetBonusBlock
;minisub_main.c,586 :: 		}
L_GetInput76:
;minisub_main.c,590 :: 		bonus_block.x -= mine_speed;
	MOV	_bonus_block+4, W1
	MOV	#lo_addr(_mine_speed), W0
	SUB	W1, [W0], W0
	MOV	W0, _bonus_block+4
;minisub_main.c,594 :: 		if(torpedoButton){
	BTSS	PORTD, #7
	GOTO	L_GetInput77
;minisub_main.c,599 :: 		LED1 = 0;
	BCLR	PORTA, #13
;minisub_main.c,601 :: 		if(torpedo_count>=1) {
	MOV	_torpedo_count, W0
	CP	W0, #1
	BRA GE	L__GetInput310
	GOTO	L_GetInput78
L__GetInput310:
;minisub_main.c,603 :: 		if( fire_torpedo_flag == 0 ) {
	MOV	_fire_torpedo_flag, W0
	CP	W0, #0
	BRA Z	L__GetInput311
	GOTO	L_GetInput79
L__GetInput311:
;minisub_main.c,605 :: 		torpedo.x = sub.x + PLAYER_WIDTH + 1;
	MOV	#63, W1
	MOV	#lo_addr(_sub), W0
	ADD	W1, [W0], W0
	INC	W0
	MOV	W0, _torpedo+4
;minisub_main.c,608 :: 		torpedo.y = sub.y + (PLAYER_HEIGHT/2);
	MOV	_sub+2, W0
	ADD	W0, #23, W0
	MOV	W0, _torpedo+6
;minisub_main.c,611 :: 		torpedo.visible = 1;
	MOV	#1, W0
	MOV	W0, _torpedo+12
;minisub_main.c,614 :: 		fire_torpedo_flag = 1;
	MOV	#1, W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,617 :: 		torpedo_count--;
	MOV	#1, W1
	MOV	#lo_addr(_torpedo_count), W0
	SUBR	W1, [W0], [W0]
;minisub_main.c,619 :: 		}
L_GetInput79:
;minisub_main.c,620 :: 		}
L_GetInput78:
;minisub_main.c,622 :: 		}
L_GetInput77:
;minisub_main.c,626 :: 		if( fire_torpedo_flag == 1 ){
	MOV	_fire_torpedo_flag, W0
	CP	W0, #1
	BRA Z	L__GetInput312
	GOTO	L_GetInput80
L__GetInput312:
;minisub_main.c,627 :: 		torpedo.x += TORPEDO_SPEED;
	MOV	_torpedo+4, W0
	ADD	W0, #12, W1
	MOV	W1, _torpedo+4
;minisub_main.c,630 :: 		if( torpedo.x > (SCREEN_WIDTH+TORPEDO_SPEED+1) ){
	MOV	#333, W0
	CP	W1, W0
	BRA GT	L__GetInput313
	GOTO	L_GetInput81
L__GetInput313:
;minisub_main.c,632 :: 		torpedo.visible = 0;
	CLR	W0
	MOV	W0, _torpedo+12
;minisub_main.c,634 :: 		fire_torpedo_flag = 0;
	CLR	W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,635 :: 		}
L_GetInput81:
;minisub_main.c,637 :: 		}
L_GetInput80:
;minisub_main.c,641 :: 		} //end of MoveSub
L_end_GetInput:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _GetInput

_RandomHeightY:

;minisub_main.c,644 :: 		int RandomHeightY(){
;minisub_main.c,645 :: 		return (rand() % 6) * ((SCREEN_HEIGHT-STATUS_TEXT_CELL_HEIGHT)/6) + STATUS_TEXT_CELL_HEIGHT;
	CALL	_rand
	MOV	#6, W2
	REPEAT	#17
	DIV.S	W0, W2
	MOV	#35, W0
	MUL.SS	W1, W0, W0
	ADD	W0, #25, W0
;minisub_main.c,646 :: 		}
L_end_RandomHeightY:
	RETURN
; end of _RandomHeightY

_RandomSeaMineType:

;minisub_main.c,648 :: 		int RandomSeaMineType(){
;minisub_main.c,649 :: 		int mine_type = 0;
;minisub_main.c,654 :: 		mine_type = rand() % grey_mine_rate;
	CALL	_rand
	MOV	_grey_mine_rate, W2
	REPEAT	#17
	DIV.S	W0, W2
	MOV	W1, W0
;minisub_main.c,657 :: 		if(mine_type == 0){
	CP	W0, #0
	BRA Z	L__RandomSeaMineType316
	GOTO	L_RandomSeaMineType82
L__RandomSeaMineType316:
;minisub_main.c,658 :: 		return 1;
	MOV	#1, W0
	GOTO	L_end_RandomSeaMineType
;minisub_main.c,659 :: 		}
L_RandomSeaMineType82:
;minisub_main.c,662 :: 		return 0;
	CLR	W0
;minisub_main.c,666 :: 		}
L_end_RandomSeaMineType:
	RETURN
; end of _RandomSeaMineType

_ResetBonusBlock:

;minisub_main.c,668 :: 		void ResetBonusBlock(){
;minisub_main.c,672 :: 		bonus_block.x = SCREEN_WIDTH*(BONUS_SCREEN_SPACING*bonus_factor);
	MOV	_bonus_factor, W0
	SL	W0, #1, W1
	MOV	#320, W0
	MUL.SS	W0, W1, W0
	MOV	W0, _bonus_block+4
;minisub_main.c,675 :: 		bonus_block.y = RandomHeightY();
	CALL	_RandomHeightY
	MOV	W0, _bonus_block+6
;minisub_main.c,678 :: 		bonus_counter += 1;
	MOV	#1, W1
	MOV	#lo_addr(_bonus_counter), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,683 :: 		if( (rand() % 3) == 0){
	CALL	_rand
	MOV	#3, W2
	REPEAT	#17
	DIV.S	W0, W2
	MOV	W1, W0
	CP	W0, #0
	BRA Z	L__ResetBonusBlock318
	GOTO	L_ResetBonusBlock84
L__ResetBonusBlock318:
;minisub_main.c,685 :: 		bonus_type = 2;
	MOV	#2, W0
	MOV	W0, _bonus_type
;minisub_main.c,686 :: 		}
	GOTO	L_ResetBonusBlock85
L_ResetBonusBlock84:
;minisub_main.c,689 :: 		bonus_type = 1;
	MOV	#1, W0
	MOV	W0, _bonus_type
;minisub_main.c,690 :: 		}
L_ResetBonusBlock85:
;minisub_main.c,691 :: 		}
L_end_ResetBonusBlock:
	RETURN
; end of _ResetBonusBlock

_ResetSeaMine:
	LNK	#2

;minisub_main.c,693 :: 		void ResetSeaMine(int mineNumber){
;minisub_main.c,696 :: 		mine[mineNumber].x += SCREEN_WIDTH;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W2
	MOV	[W2], W1
	MOV	#320, W0
	ADD	W1, W0, [W2]
;minisub_main.c,697 :: 		mine[mineNumber].y = RandomHeightY();
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W0
	MOV	W0, [W14+0]
	CALL	_RandomHeightY
	MOV	[W14+0], W1
	MOV	W0, [W1]
;minisub_main.c,700 :: 		mine[mineNumber].type = RandomSeaMineType();
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W0
	MOV	W0, [W14+0]
	CALL	_RandomSeaMineType
	MOV	[W14+0], W1
	MOV	W0, [W1]
;minisub_main.c,703 :: 		mine[mineNumber].hits = 0;
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #16, W1
	CLR	W0
	MOV	W0, [W1]
;minisub_main.c,704 :: 		}
L_end_ResetSeaMine:
	ULNK
	RETURN
; end of _ResetSeaMine

_UART2_Write_Line:

;minisub_main.c,708 :: 		void UART2_Write_Line(char *uart_text) {
;minisub_main.c,709 :: 		UART2_Write_Text(uart_text);
	PUSH	W10
	CALL	_UART2_Write_Text
;minisub_main.c,710 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,711 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,712 :: 		}
L_end_UART2_Write_Line:
	POP	W10
	RETURN
; end of _UART2_Write_Line

_UART2_Write_Variable:
	LNK	#12

;minisub_main.c,715 :: 		void UART2_Write_Variable(int var) {
;minisub_main.c,717 :: 		IntToStr(var, var_txt);
	PUSH	W10
	PUSH	W11
	ADD	W14, #0, W0
	MOV	W0, W11
	CALL	_IntToStr
;minisub_main.c,718 :: 		UART2_Write_Text(var_txt);
	ADD	W14, #0, W0
	MOV	W0, W10
	CALL	_UART2_Write_Text
;minisub_main.c,719 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,720 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,721 :: 		}
L_end_UART2_Write_Variable:
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _UART2_Write_Variable

_UART2_Write_Long_Variable:
	LNK	#20

;minisub_main.c,724 :: 		void UART2_Write_Long_Variable(long var){
;minisub_main.c,726 :: 		LongWordToStr(var, var_txt);
	PUSH	W10
	PUSH	W11
	PUSH	W12
	ADD	W14, #0, W0
	MOV	W0, W12
	CALL	_LongWordToStr
;minisub_main.c,727 :: 		UART2_Write_Text(var_txt);
	ADD	W14, #0, W0
	MOV	W0, W10
	CALL	_UART2_Write_Text
;minisub_main.c,728 :: 		UART2_Write(13);
	MOV	#13, W10
	CALL	_UART2_Write
;minisub_main.c,729 :: 		UART2_Write(10);
	MOV	#10, W10
	CALL	_UART2_Write
;minisub_main.c,730 :: 		}
L_end_UART2_Write_Long_Variable:
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _UART2_Write_Long_Variable

_RenderScreen:
	LNK	#2

;minisub_main.c,735 :: 		void RenderScreen(){
;minisub_main.c,736 :: 		int mine_inc = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,739 :: 		int redraw_border = 3;
;minisub_main.c,742 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	CLR	W0
	MOV	W0, [W14+0]
L_RenderScreen86:
	MOV	[W14+0], W0
	CP	W0, #3
	BRA LE	L__RenderScreen324
	GOTO	L_RenderScreen87
L__RenderScreen324:
;minisub_main.c,744 :: 		clear_mine[mine_inc].top =  mine[mine_inc].prev_y;
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	MOV	W0, W4
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W0
	MOV	[W0], [W4]
;minisub_main.c,745 :: 		if(clear_mine[mine_inc].top < 0)
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__RenderScreen325
	GOTO	L_RenderScreen89
L__RenderScreen325:
;minisub_main.c,746 :: 		clear_mine[mine_inc].top = 0;
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W1
	CLR	W0
	MOV	W0, [W1]
L_RenderScreen89:
;minisub_main.c,748 :: 		clear_mine[mine_inc].left =  mine[mine_inc].x + mine[mine_inc].width;
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #2, W5
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #4, W0
	MOV	[W0], W1
	MOV	[W4], W0
	ADD	W1, W0, [W5]
;minisub_main.c,749 :: 		if(clear_mine[mine_inc].left < 0)
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	INC2	W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__RenderScreen326
	GOTO	L_RenderScreen90
L__RenderScreen326:
;minisub_main.c,750 :: 		clear_mine[mine_inc].left = 0;
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #2, W1
	CLR	W0
	MOV	W0, [W1]
L_RenderScreen90:
;minisub_main.c,752 :: 		clear_mine[mine_inc].right = mine[mine_inc].prev_x + mine[mine_inc].width;
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #6, W5
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #8, W0
	MOV	[W0], W1
	MOV	[W4], W0
	ADD	W1, W0, [W5]
;minisub_main.c,753 :: 		if(clear_mine[mine_inc].right < 0)
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #6, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__RenderScreen327
	GOTO	L_RenderScreen91
L__RenderScreen327:
;minisub_main.c,754 :: 		clear_mine[mine_inc].right = 0;
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #6, W1
	CLR	W0
	MOV	W0, [W1]
L_RenderScreen91:
;minisub_main.c,756 :: 		clear_mine[mine_inc].bottom = mine[mine_inc].prev_y + mine[mine_inc].height;
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #4, W5
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #10, W0
	MOV	[W0], W1
	ADD	W4, #2, W0
	ADD	W1, [W0], [W5]
;minisub_main.c,757 :: 		if(clear_mine[mine_inc].bottom < 0)
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #4, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA LT	L__RenderScreen328
	GOTO	L_RenderScreen92
L__RenderScreen328:
;minisub_main.c,758 :: 		clear_mine[mine_inc].bottom = 0;
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #4, W1
	CLR	W0
	MOV	W0, [W1]
L_RenderScreen92:
;minisub_main.c,742 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
;minisub_main.c,760 :: 		}
	GOTO	L_RenderScreen86
L_RenderScreen87:
;minisub_main.c,763 :: 		if(sub.x > sub.prev_x){
	MOV	_sub, W1
	MOV	#lo_addr(_sub+4), W0
	CP	W1, [W0]
	BRA GT	L__RenderScreen329
	GOTO	L_RenderScreen93
L__RenderScreen329:
;minisub_main.c,764 :: 		clear_sub.left = sub.prev_x;
	MOV	_sub+4, W0
	MOV	W0, _clear_sub+2
;minisub_main.c,765 :: 		clear_sub.right =  sub.x;
	MOV	_sub, W0
	MOV	W0, _clear_sub+6
;minisub_main.c,766 :: 		clear_sub.top = sub.y;
	MOV	_sub+2, W0
	MOV	W0, _clear_sub
;minisub_main.c,767 :: 		clear_sub.bottom = sub.y + PLAYER_HEIGHT;
	MOV	#47, W1
	MOV	#lo_addr(_sub+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+4
;minisub_main.c,768 :: 		}
L_RenderScreen93:
;minisub_main.c,771 :: 		if(sub.x < sub.prev_x){
	MOV	_sub, W1
	MOV	#lo_addr(_sub+4), W0
	CP	W1, [W0]
	BRA LT	L__RenderScreen330
	GOTO	L_RenderScreen94
L__RenderScreen330:
;minisub_main.c,772 :: 		clear_sub.left = sub.x+PLAYER_WIDTH;
	MOV	#63, W1
	MOV	#lo_addr(_sub), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+2
;minisub_main.c,773 :: 		clear_sub.right = sub.prev_x+PLAYER_WIDTH;
	MOV	#63, W1
	MOV	#lo_addr(_sub+4), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+6
;minisub_main.c,774 :: 		clear_sub.top = sub.y;
	MOV	_sub+2, W0
	MOV	W0, _clear_sub
;minisub_main.c,775 :: 		clear_sub.bottom = sub.y + PLAYER_HEIGHT;
	MOV	#47, W1
	MOV	#lo_addr(_sub+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+4
;minisub_main.c,776 :: 		}
L_RenderScreen94:
;minisub_main.c,780 :: 		if(sub.y > sub.prev_y){
	MOV	_sub+2, W1
	MOV	#lo_addr(_sub+6), W0
	CP	W1, [W0]
	BRA GT	L__RenderScreen331
	GOTO	L_RenderScreen95
L__RenderScreen331:
;minisub_main.c,781 :: 		clear_sub.left =  sub.x;
	MOV	_sub, W0
	MOV	W0, _clear_sub+2
;minisub_main.c,782 :: 		clear_sub.right =  sub.x+PLAYER_WIDTH;
	MOV	#63, W1
	MOV	#lo_addr(_sub), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+6
;minisub_main.c,783 :: 		clear_sub.top = sub.prev_y;
	MOV	_sub+6, W0
	MOV	W0, _clear_sub
;minisub_main.c,784 :: 		clear_sub.bottom =  sub.y;
	MOV	_sub+2, W0
	MOV	W0, _clear_sub+4
;minisub_main.c,785 :: 		}
L_RenderScreen95:
;minisub_main.c,788 :: 		if(sub.y < sub.prev_y){
	MOV	_sub+2, W1
	MOV	#lo_addr(_sub+6), W0
	CP	W1, [W0]
	BRA LT	L__RenderScreen332
	GOTO	L_RenderScreen96
L__RenderScreen332:
;minisub_main.c,789 :: 		clear_sub.left =  sub.x;
	MOV	_sub, W0
	MOV	W0, _clear_sub+2
;minisub_main.c,790 :: 		clear_sub.right =  sub.x+PLAYER_WIDTH;
	MOV	#63, W1
	MOV	#lo_addr(_sub), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+6
;minisub_main.c,791 :: 		clear_sub.top = sub.y + PLAYER_HEIGHT;
	MOV	#47, W1
	MOV	#lo_addr(_sub+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub
;minisub_main.c,792 :: 		clear_sub.bottom = sub.prev_y + PLAYER_HEIGHT;
	MOV	#47, W1
	MOV	#lo_addr(_sub+6), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_sub+4
;minisub_main.c,793 :: 		}
L_RenderScreen96:
;minisub_main.c,797 :: 		if (clear_sub.left <=0)
	MOV	_clear_sub+2, W0
	CP	W0, #0
	BRA LE	L__RenderScreen333
	GOTO	L_RenderScreen97
L__RenderScreen333:
;minisub_main.c,798 :: 		clear_sub.left = 0;
	CLR	W0
	MOV	W0, _clear_sub+2
L_RenderScreen97:
;minisub_main.c,801 :: 		if (clear_sub.top <= STATUS_TEXT_CELL_HEIGHT)
	MOV	_clear_sub, W0
	CP	W0, #25
	BRA LE	L__RenderScreen334
	GOTO	L_RenderScreen98
L__RenderScreen334:
;minisub_main.c,802 :: 		clear_sub.top = STATUS_TEXT_CELL_HEIGHT;
	MOV	#25, W0
	MOV	W0, _clear_sub
L_RenderScreen98:
;minisub_main.c,805 :: 		clear_torpedo.left = torpedo.prev_x-1;
	MOV	_torpedo+8, W0
	SUB	W0, #1, W2
	MOV	W2, _clear_torpedo+2
;minisub_main.c,806 :: 		clear_torpedo.top =  torpedo.prev_y-1;
	MOV	_torpedo+10, W0
	DEC	W0
	MOV	W0, _clear_torpedo
;minisub_main.c,807 :: 		clear_torpedo.right =  torpedo.x;
	MOV	_torpedo+4, W0
	MOV	W0, _clear_torpedo+6
;minisub_main.c,808 :: 		clear_torpedo.bottom =  torpedo.y+torpedo.height+1;
	MOV	_torpedo+6, W1
	MOV	#lo_addr(_torpedo+2), W0
	ADD	W1, [W0], W0
	INC	W0
	MOV	W0, _clear_torpedo+4
;minisub_main.c,812 :: 		if (clear_torpedo.left <=0)
	CP	W2, #0
	BRA LE	L__RenderScreen335
	GOTO	L_RenderScreen99
L__RenderScreen335:
;minisub_main.c,813 :: 		clear_torpedo.left = 0;
	CLR	W0
	MOV	W0, _clear_torpedo+2
L_RenderScreen99:
;minisub_main.c,815 :: 		if (clear_torpedo.top <=0)
	MOV	_clear_torpedo, W0
	CP	W0, #0
	BRA LE	L__RenderScreen336
	GOTO	L_RenderScreen100
L__RenderScreen336:
;minisub_main.c,816 :: 		clear_torpedo.top = 0;
	CLR	W0
	MOV	W0, _clear_torpedo
L_RenderScreen100:
;minisub_main.c,820 :: 		clear_bonus_block.top =  bonus_block.prev_y;
	MOV	_bonus_block+10, W0
	MOV	W0, _clear_bonus_block
;minisub_main.c,821 :: 		if(clear_bonus_block.top < 0)
	MOV	_bonus_block+10, W0
	CP	W0, #0
	BRA LT	L__RenderScreen337
	GOTO	L_RenderScreen101
L__RenderScreen337:
;minisub_main.c,822 :: 		clear_bonus_block.top = 0;
	CLR	W0
	MOV	W0, _clear_bonus_block
L_RenderScreen101:
;minisub_main.c,824 :: 		clear_bonus_block.left =  bonus_block.x + bonus_block.width;
	MOV	_bonus_block+4, W1
	MOV	#lo_addr(_bonus_block), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_bonus_block+2
;minisub_main.c,825 :: 		if(clear_bonus_block.left < 0)
	CP	W0, #0
	BRA LT	L__RenderScreen338
	GOTO	L_RenderScreen102
L__RenderScreen338:
;minisub_main.c,826 :: 		clear_bonus_block.left = 0;
	CLR	W0
	MOV	W0, _clear_bonus_block+2
L_RenderScreen102:
;minisub_main.c,828 :: 		clear_bonus_block.right = bonus_block.prev_x + bonus_block.width;
	MOV	_bonus_block+8, W1
	MOV	#lo_addr(_bonus_block), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_bonus_block+6
;minisub_main.c,829 :: 		if(clear_bonus_block.right < 0)
	CP	W0, #0
	BRA LT	L__RenderScreen339
	GOTO	L_RenderScreen103
L__RenderScreen339:
;minisub_main.c,830 :: 		clear_bonus_block.right = 0;
	CLR	W0
	MOV	W0, _clear_bonus_block+6
L_RenderScreen103:
;minisub_main.c,832 :: 		clear_bonus_block.bottom = bonus_block.prev_y + bonus_block.height;
	MOV	_bonus_block+10, W1
	MOV	#lo_addr(_bonus_block+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_bonus_block+4
;minisub_main.c,833 :: 		if(clear_bonus_block.bottom < 0)
	CP	W0, #0
	BRA LT	L__RenderScreen340
	GOTO	L_RenderScreen104
L__RenderScreen340:
;minisub_main.c,834 :: 		clear_bonus_block.bottom = 0;
	CLR	W0
	MOV	W0, _clear_bonus_block+4
L_RenderScreen104:
;minisub_main.c,838 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,841 :: 		if( (sub.prev_x != sub.x)|| (sub.prev_y != sub.y) || (sub.x < (0)) || (sub.y < (STATUS_TEXT_CELL_HEIGHT)) ){
	MOV	_sub+4, W1
	MOV	#lo_addr(_sub), W0
	CP	W1, [W0]
	BRA Z	L__RenderScreen341
	GOTO	L__RenderScreen268
L__RenderScreen341:
	MOV	_sub+6, W1
	MOV	#lo_addr(_sub+2), W0
	CP	W1, [W0]
	BRA Z	L__RenderScreen342
	GOTO	L__RenderScreen267
L__RenderScreen342:
	MOV	_sub, W0
	CP	W0, #0
	BRA GE	L__RenderScreen343
	GOTO	L__RenderScreen266
L__RenderScreen343:
	MOV	_sub+2, W0
	CP	W0, #25
	BRA GE	L__RenderScreen344
	GOTO	L__RenderScreen265
L__RenderScreen344:
	GOTO	L_RenderScreen107
L__RenderScreen268:
L__RenderScreen267:
L__RenderScreen266:
L__RenderScreen265:
;minisub_main.c,843 :: 		TFT_Rectangle(clear_sub.left, clear_sub.top, clear_sub.right, clear_sub.bottom);
	MOV	_clear_sub+4, W13
	MOV	_clear_sub+6, W12
	MOV	_clear_sub, W11
	MOV	_clear_sub+2, W10
	CALL	_TFT_Rectangle
;minisub_main.c,844 :: 		}
L_RenderScreen107:
;minisub_main.c,847 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	CLR	W0
	MOV	W0, [W14+0]
L_RenderScreen108:
	MOV	[W14+0], W0
	CP	W0, #3
	BRA LE	L__RenderScreen345
	GOTO	L_RenderScreen109
L__RenderScreen345:
;minisub_main.c,848 :: 		TFT_Rectangle( clear_mine[mine_inc].left, clear_mine[mine_inc].top, clear_mine[mine_inc].right, clear_mine[mine_inc].bottom);
	MOV	[W14+0], W0
	SL	W0, #3, W1
	MOV	#lo_addr(_clear_mine), W0
	ADD	W0, W1, W0
	ADD	W0, #4, W3
	ADD	W0, #6, W2
	MOV	[W0], W1
	INC2	W0
	MOV	[W3], W13
	MOV	[W2], W12
	MOV	W1, W11
	MOV	[W0], W10
	CALL	_TFT_Rectangle
;minisub_main.c,847 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
;minisub_main.c,849 :: 		}
	GOTO	L_RenderScreen108
L_RenderScreen109:
;minisub_main.c,852 :: 		if(bonus_block.x <= SCREEN_WIDTH){
	MOV	_bonus_block+4, W1
	MOV	#320, W0
	CP	W1, W0
	BRA LE	L__RenderScreen346
	GOTO	L_RenderScreen111
L__RenderScreen346:
;minisub_main.c,854 :: 		TFT_Rectangle( clear_bonus_block.left, clear_bonus_block.top, clear_bonus_block.right, clear_bonus_block.bottom);
	MOV	_clear_bonus_block+4, W13
	MOV	_clear_bonus_block+6, W12
	MOV	_clear_bonus_block, W11
	MOV	_clear_bonus_block+2, W10
	CALL	_TFT_Rectangle
;minisub_main.c,855 :: 		}
L_RenderScreen111:
;minisub_main.c,859 :: 		if(fire_torpedo_flag){
	MOV	#lo_addr(_fire_torpedo_flag), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen347
	GOTO	L_RenderScreen112
L__RenderScreen347:
;minisub_main.c,863 :: 		TFT_Rectangle( clear_torpedo.left, clear_torpedo.top, clear_torpedo.right, clear_torpedo.bottom);
	MOV	_clear_torpedo+4, W13
	MOV	_clear_torpedo+6, W12
	MOV	_clear_torpedo, W11
	MOV	_clear_torpedo+2, W10
	CALL	_TFT_Rectangle
;minisub_main.c,864 :: 		}
L_RenderScreen112:
;minisub_main.c,867 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,876 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	CLR	W0
	MOV	W0, [W14+0]
L_RenderScreen113:
	MOV	[W14+0], W0
	CP	W0, #3
	BRA LE	L__RenderScreen348
	GOTO	L_RenderScreen114
L__RenderScreen348:
;minisub_main.c,878 :: 		AnimateSeaMine(mine_inc);
	MOV	[W14+0], W10
	CALL	_AnimateSeaMine
;minisub_main.c,876 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
;minisub_main.c,879 :: 		}
	GOTO	L_RenderScreen113
L_RenderScreen114:
;minisub_main.c,882 :: 		if(bonus_block.x <= SCREEN_WIDTH){
	MOV	_bonus_block+4, W1
	MOV	#320, W0
	CP	W1, W0
	BRA LE	L__RenderScreen349
	GOTO	L_RenderScreen116
L__RenderScreen349:
;minisub_main.c,885 :: 		if(bonus_type == 2) {
	MOV	_bonus_type, W0
	CP	W0, #2
	BRA Z	L__RenderScreen350
	GOTO	L_RenderScreen117
L__RenderScreen350:
;minisub_main.c,887 :: 		TFT_Image(bonus_block.x, bonus_block.y, heart_pack_bmp, 1);
	MOV	#lo_addr(_heart_pack_bmp), W0
	MOV	#higher_addr(_heart_pack_bmp), W1
	MOV.D	W0, W12
	MOV	_bonus_block+6, W11
	MOV	_bonus_block+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,888 :: 		}
	GOTO	L_RenderScreen118
L_RenderScreen117:
;minisub_main.c,891 :: 		TFT_Image(bonus_block.x, bonus_block.y, torpedo_pack_bmp, 1);
	MOV	#lo_addr(_torpedo_pack_bmp), W0
	MOV	#higher_addr(_torpedo_pack_bmp), W1
	MOV.D	W0, W12
	MOV	_bonus_block+6, W11
	MOV	_bonus_block+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,892 :: 		}
L_RenderScreen118:
;minisub_main.c,893 :: 		}
L_RenderScreen116:
;minisub_main.c,896 :: 		if(fire_torpedo_flag){
	MOV	#lo_addr(_fire_torpedo_flag), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen351
	GOTO	L_RenderScreen119
L__RenderScreen351:
;minisub_main.c,897 :: 		TFT_Image(torpedo.x, torpedo.y, torpedo_bmp, 1);
	MOV	#lo_addr(_torpedo_bmp), W0
	MOV	#higher_addr(_torpedo_bmp), W1
	MOV.D	W0, W12
	MOV	_torpedo+6, W11
	MOV	_torpedo+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,898 :: 		}
L_RenderScreen119:
;minisub_main.c,902 :: 		TFT_Image(sub.x, sub.y, sub_bmp, 1);
	MOV	#lo_addr(_sub_bmp), W0
	MOV	#higher_addr(_sub_bmp), W1
	MOV.D	W0, W12
	MOV	_sub+2, W11
	MOV	_sub, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,909 :: 		if( (sub.prev_x != sub.x)|| (sub.prev_y != sub.y) || (sub.x < (0)) || (sub.y < (STATUS_TEXT_CELL_HEIGHT)) ){
	MOV	_sub+4, W1
	MOV	#lo_addr(_sub), W0
	CP	W1, [W0]
	BRA Z	L__RenderScreen352
	GOTO	L__RenderScreen272
L__RenderScreen352:
	MOV	_sub+6, W1
	MOV	#lo_addr(_sub+2), W0
	CP	W1, [W0]
	BRA Z	L__RenderScreen353
	GOTO	L__RenderScreen271
L__RenderScreen353:
	MOV	_sub, W0
	CP	W0, #0
	BRA GE	L__RenderScreen354
	GOTO	L__RenderScreen270
L__RenderScreen354:
	MOV	_sub+2, W0
	CP	W0, #25
	BRA GE	L__RenderScreen355
	GOTO	L__RenderScreen269
L__RenderScreen355:
	GOTO	L_RenderScreen122
L__RenderScreen272:
L__RenderScreen271:
L__RenderScreen270:
L__RenderScreen269:
;minisub_main.c,911 :: 		TFT_Rectangle(clear_sub.left, clear_sub.top, clear_sub.right, clear_sub.bottom);
	MOV	_clear_sub+4, W13
	MOV	_clear_sub+6, W12
	MOV	_clear_sub, W11
	MOV	_clear_sub+2, W10
	CALL	_TFT_Rectangle
;minisub_main.c,912 :: 		}
L_RenderScreen122:
;minisub_main.c,916 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	CLR	W0
	MOV	W0, [W14+0]
L_RenderScreen123:
	MOV	[W14+0], W0
	CP	W0, #3
	BRA LE	L__RenderScreen356
	GOTO	L_RenderScreen124
L__RenderScreen356:
;minisub_main.c,918 :: 		if(IsCollision(sub.x, sub.y, PLAYER_WIDTH, PLAYER_HEIGHT, mine[mine_inc].x, mine[mine_inc].y, mine[mine_inc].width, mine[mine_inc].height)) {
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #2, W3
	MOV	[W4], W2
	ADD	W4, #6, W0
	MOV	[W0], W1
	ADD	W4, #4, W0
	MOV	[W0], W0
	MOV	#47, W13
	MOV	#63, W12
	MOV	_sub+2, W11
	MOV	_sub, W10
	PUSH	[W3]
	PUSH	W2
	PUSH	W1
	PUSH	W0
	CALL	_IsCollision
	SUB	#8, W15
	CP0.B	W0
	BRA NZ	L__RenderScreen357
	GOTO	L_RenderScreen126
L__RenderScreen357:
;minisub_main.c,920 :: 		mineHit = 1;
	MOV	#1, W0
	MOV	W0, _mineHit
;minisub_main.c,923 :: 		destroyed_mine_id = mine_inc;
	MOV	[W14+0], W0
	MOV	W0, _destroyed_mine_id
;minisub_main.c,926 :: 		UART2_Write_Line("You hit a sea mine!");
	MOV	#lo_addr(?lstr30_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,929 :: 		}
L_RenderScreen126:
;minisub_main.c,931 :: 		if(fire_torpedo_flag){
	MOV	#lo_addr(_fire_torpedo_flag), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen358
	GOTO	L_RenderScreen127
L__RenderScreen358:
;minisub_main.c,933 :: 		if(IsCollision(torpedo.x, torpedo.y, torpedo.width, torpedo.height, mine[mine_inc].x, mine[mine_inc].y, mine[mine_inc].width, mine[mine_inc].height)) {
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W4
	ADD	W4, #2, W3
	MOV	[W4], W2
	ADD	W4, #6, W0
	MOV	[W0], W1
	ADD	W4, #4, W0
	MOV	[W0], W0
	MOV	_torpedo+2, W13
	MOV	_torpedo, W12
	MOV	_torpedo+6, W11
	MOV	_torpedo+4, W10
	PUSH	[W3]
	PUSH	W2
	PUSH	W1
	PUSH	W0
	CALL	_IsCollision
	SUB	#8, W15
	CP0.B	W0
	BRA NZ	L__RenderScreen359
	GOTO	L_RenderScreen128
L__RenderScreen359:
;minisub_main.c,936 :: 		mine[mine_inc].hits++;
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #16, W1
	MOV	[W1], W0
	INC	W0
	MOV	W0, [W1]
;minisub_main.c,939 :: 		if(mine[mine_inc].type == 0){
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA Z	L__RenderScreen360
	GOTO	L_RenderScreen129
L__RenderScreen360:
;minisub_main.c,941 :: 		mineExplode = 1;
	MOV	#1, W0
	MOV	W0, _mineExplode
;minisub_main.c,944 :: 		destroyed_mine_id = mine_inc;
	MOV	[W14+0], W0
	MOV	W0, _destroyed_mine_id
;minisub_main.c,947 :: 		UART2_Write_Line("Your torpedo destroyed a red sea mine!");
	MOV	#lo_addr(?lstr31_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,948 :: 		}
	GOTO	L_RenderScreen130
L_RenderScreen129:
;minisub_main.c,949 :: 		else if( (mine[mine_inc].type == 1) && (mine[mine_inc].hits >= 2) ){
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W0
	MOV	[W0], W0
	CP	W0, #1
	BRA Z	L__RenderScreen361
	GOTO	L__RenderScreen274
L__RenderScreen361:
	MOV	#18, W1
	ADD	W14, #0, W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #16, W0
	MOV	[W0], W0
	CP	W0, #2
	BRA GE	L__RenderScreen362
	GOTO	L__RenderScreen273
L__RenderScreen362:
L__RenderScreen262:
;minisub_main.c,951 :: 		mineExplode = 1;
	MOV	#1, W0
	MOV	W0, _mineExplode
;minisub_main.c,954 :: 		destroyed_mine_id = mine_inc;
	MOV	[W14+0], W0
	MOV	W0, _destroyed_mine_id
;minisub_main.c,957 :: 		UART2_Write_Line("Your torpedo destroyed a grey sea mine!");
	MOV	#lo_addr(?lstr32_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,958 :: 		}
	GOTO	L_RenderScreen134
;minisub_main.c,949 :: 		else if( (mine[mine_inc].type == 1) && (mine[mine_inc].hits >= 2) ){
L__RenderScreen274:
L__RenderScreen273:
;minisub_main.c,963 :: 		fire_torpedo_flag = 0;
	CLR	W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,966 :: 		ClearTorpedo();
	CALL	_ClearTorpedo
;minisub_main.c,969 :: 		torpedo.x = 0;
	CLR	W0
	MOV	W0, _torpedo+4
;minisub_main.c,970 :: 		torpedo.y = 0;
	CLR	W0
	MOV	W0, _torpedo+6
;minisub_main.c,971 :: 		torpedo.prev_x = 0;
	CLR	W0
	MOV	W0, _torpedo+8
;minisub_main.c,972 :: 		torpedo.prev_y = 0;
	CLR	W0
	MOV	W0, _torpedo+10
;minisub_main.c,974 :: 		}
L_RenderScreen134:
L_RenderScreen130:
;minisub_main.c,977 :: 		}
L_RenderScreen128:
;minisub_main.c,978 :: 		}
L_RenderScreen127:
;minisub_main.c,916 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
;minisub_main.c,982 :: 		}
	GOTO	L_RenderScreen123
L_RenderScreen124:
;minisub_main.c,986 :: 		if(IsCollision(sub.x, sub.y, PLAYER_WIDTH, PLAYER_HEIGHT, bonus_block.x, bonus_block.y, bonus_block.width, bonus_block.height)) {
	MOV	#47, W13
	MOV	#63, W12
	MOV	_sub+2, W11
	MOV	_sub, W10
	PUSH	_bonus_block+2
	PUSH	_bonus_block
	PUSH	_bonus_block+6
	PUSH	_bonus_block+4
	CALL	_IsCollision
	SUB	#8, W15
	CP0.B	W0
	BRA NZ	L__RenderScreen363
	GOTO	L_RenderScreen135
L__RenderScreen363:
;minisub_main.c,989 :: 		bonus_id = 1;
	MOV	#1, W0
	MOV	W0, _bonus_id
;minisub_main.c,992 :: 		if(bonus_type == 2){
	MOV	_bonus_type, W0
	CP	W0, #2
	BRA Z	L__RenderScreen364
	GOTO	L_RenderScreen136
L__RenderScreen364:
;minisub_main.c,994 :: 		subLives += 1;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,997 :: 		UART2_Write_Line("You picked up an extra life bonus!");
	MOV	#lo_addr(?lstr33_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,998 :: 		}
	GOTO	L_RenderScreen137
L_RenderScreen136:
;minisub_main.c,1001 :: 		torpedo_count += 3;
	MOV	#3, W1
	MOV	#lo_addr(_torpedo_count), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1004 :: 		UART2_Write_Line("You picked up a torpedo 3 pack bonus!");
	MOV	#lo_addr(?lstr34_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,1005 :: 		}
L_RenderScreen137:
;minisub_main.c,1009 :: 		ResetBonusBlock();
	CALL	_ResetBonusBlock
;minisub_main.c,1012 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,1013 :: 		}
L_RenderScreen135:
;minisub_main.c,1018 :: 		if(mineHit){
	MOV	#lo_addr(_mineHit), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen365
	GOTO	L_RenderScreen138
L__RenderScreen365:
;minisub_main.c,1022 :: 		fireball.x = (sub.x + (PLAYER_WIDTH/2) ) - (fireball.width/2) ;
	MOV	_sub, W0
	ADD	W0, #31, W1
	MOV	_fireball, W0
	LSR	W0, #1, W0
	SUB	W1, W0, W2
	MOV	W2, _fireball+4
;minisub_main.c,1023 :: 		fireball.y = (sub.y + (PLAYER_HEIGHT/2) ) - (fireball.height/2) ;
	MOV	_sub+2, W0
	ADD	W0, #23, W1
	MOV	_fireball+2, W0
	LSR	W0, #1, W0
	SUB	W1, W0, W0
	MOV	W0, _fireball+6
;minisub_main.c,1026 :: 		if( fireball.x <=0)
	CP	W2, #0
	BRA LE	L__RenderScreen366
	GOTO	L_RenderScreen139
L__RenderScreen366:
;minisub_main.c,1027 :: 		fireball.x=0;
	CLR	W0
	MOV	W0, _fireball+4
L_RenderScreen139:
;minisub_main.c,1029 :: 		if( fireball.y <= STATUS_TEXT_CELL_HEIGHT)
	MOV	_fireball+6, W0
	CP	W0, #25
	BRA LE	L__RenderScreen367
	GOTO	L_RenderScreen140
L__RenderScreen367:
;minisub_main.c,1030 :: 		fireball.y = STATUS_TEXT_CELL_HEIGHT;
	MOV	#25, W0
	MOV	W0, _fireball+6
L_RenderScreen140:
;minisub_main.c,1033 :: 		TFT_Image(fireball.x, fireball.y, fireball_bmp, 1);
	MOV	#lo_addr(_fireball_bmp), W0
	MOV	#higher_addr(_fireball_bmp), W1
	MOV.D	W0, W12
	MOV	_fireball+6, W11
	MOV	_fireball+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1036 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,1038 :: 		}
L_RenderScreen138:
;minisub_main.c,1043 :: 		if(mineExplode){
	MOV	#lo_addr(_mineExplode), W0
	CP0	[W0]
	BRA NZ	L__RenderScreen368
	GOTO	L_RenderScreen141
L__RenderScreen368:
;minisub_main.c,1051 :: 		ClearTorpedo();
	CALL	_ClearTorpedo
;minisub_main.c,1054 :: 		explode.x = (mine[destroyed_mine_id].x + (mine[destroyed_mine_id].width/2) ) - (explode.width/2) ;
	MOV	#18, W1
	MOV	#lo_addr(_destroyed_mine_id), W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W3
	ADD	W3, #4, W0
	MOV	[W0], W1
	MOV	[W3], W0
	LSR	W0, #1, W0
	ADD	W1, W0, W1
	MOV	_explode, W0
	LSR	W0, #1, W0
	SUB	W1, W0, W2
	MOV	W2, _explode+4
;minisub_main.c,1055 :: 		explode.y = (mine[destroyed_mine_id].y + (mine[destroyed_mine_id].height/2) ) - (explode.height/2);
	ADD	W3, #6, W0
	MOV	[W0], W1
	ADD	W3, #2, W0
	MOV	[W0], W0
	LSR	W0, #1, W0
	ADD	W1, W0, W1
	MOV	_explode+2, W0
	LSR	W0, #1, W0
	SUB	W1, W0, W0
	MOV	W0, _explode+6
;minisub_main.c,1058 :: 		if( explode.x <=0 ){
	CP	W2, #0
	BRA LE	L__RenderScreen369
	GOTO	L_RenderScreen142
L__RenderScreen369:
;minisub_main.c,1059 :: 		explode.x=0;
	CLR	W0
	MOV	W0, _explode+4
;minisub_main.c,1060 :: 		}
L_RenderScreen142:
;minisub_main.c,1062 :: 		if( explode.y <= STATUS_TEXT_CELL_HEIGHT){
	MOV	_explode+6, W0
	CP	W0, #25
	BRA LE	L__RenderScreen370
	GOTO	L_RenderScreen143
L__RenderScreen370:
;minisub_main.c,1063 :: 		explode.y = STATUS_TEXT_CELL_HEIGHT;
	MOV	#25, W0
	MOV	W0, _explode+6
;minisub_main.c,1064 :: 		}
L_RenderScreen143:
;minisub_main.c,1067 :: 		TFT_Image(explode.x, explode.y, explode_bmp, 1);
	MOV	#lo_addr(_explode_bmp), W0
	MOV	#higher_addr(_explode_bmp), W1
	MOV.D	W0, W12
	MOV	_explode+6, W11
	MOV	_explode+4, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1068 :: 		Delay_ms(100);
	MOV	#17, W8
	MOV	#18095, W7
L_RenderScreen144:
	DEC	W7
	BRA NZ	L_RenderScreen144
	DEC	W8
	BRA NZ	L_RenderScreen144
;minisub_main.c,1071 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,1075 :: 		mineExplode = 0;
	CLR	W0
	MOV	W0, _mineExplode
;minisub_main.c,1078 :: 		fire_torpedo_flag = 0;
	CLR	W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,1081 :: 		torpedo.x = 0;
	CLR	W0
	MOV	W0, _torpedo+4
;minisub_main.c,1082 :: 		torpedo.y = 0;
	CLR	W0
	MOV	W0, _torpedo+6
;minisub_main.c,1083 :: 		torpedo.prev_x = 0;
	CLR	W0
	MOV	W0, _torpedo+8
;minisub_main.c,1084 :: 		torpedo.prev_y = 0;
	CLR	W0
	MOV	W0, _torpedo+10
;minisub_main.c,1088 :: 		ResetSeaMine(destroyed_mine_id);
	MOV	_destroyed_mine_id, W10
	CALL	_ResetSeaMine
;minisub_main.c,1089 :: 		mine[destroyed_mine_id].prev_x = mine[destroyed_mine_id].x;
	MOV	#18, W1
	MOV	#lo_addr(_destroyed_mine_id), W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W1
	ADD	W0, #4, W0
	MOV	[W0], [W1]
;minisub_main.c,1092 :: 		if(mine[destroyed_mine_id].type == 0){
	MOV	#18, W1
	MOV	#lo_addr(_destroyed_mine_id), W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA Z	L__RenderScreen371
	GOTO	L_RenderScreen146
L__RenderScreen371:
;minisub_main.c,1093 :: 		score += 50;
	MOV	#50, W1
	MOV	#lo_addr(_score), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1094 :: 		}
	GOTO	L_RenderScreen147
L_RenderScreen146:
;minisub_main.c,1095 :: 		else if(mine[destroyed_mine_id].type == 1){
	MOV	#18, W1
	MOV	#lo_addr(_destroyed_mine_id), W0
	MUL.UU	W1, [W0], W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W0
	MOV	[W0], W0
	CP	W0, #1
	BRA Z	L__RenderScreen372
	GOTO	L_RenderScreen148
L__RenderScreen372:
;minisub_main.c,1096 :: 		score += 100;
	MOV	#100, W1
	MOV	#lo_addr(_score), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1097 :: 		}
L_RenderScreen148:
L_RenderScreen147:
;minisub_main.c,1098 :: 		}
L_RenderScreen141:
;minisub_main.c,1101 :: 		CheckGameLevel();
	CALL	_CheckGameLevel
;minisub_main.c,1105 :: 		RenderScore();
	CALL	_RenderScore
;minisub_main.c,1107 :: 		}
L_end_RenderScreen:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _RenderScreen

_CheckGameLevel:

;minisub_main.c,1110 :: 		void CheckGameLevel(){
;minisub_main.c,1112 :: 		if( (level == 1) && (score > 1000) ){
	MOV	_level, W0
	CP	W0, #1
	BRA Z	L__CheckGameLevel374
	GOTO	L__CheckGameLevel241
L__CheckGameLevel374:
	MOV	_score, W1
	MOV	#1000, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel375
	GOTO	L__CheckGameLevel240
L__CheckGameLevel375:
L__CheckGameLevel239:
;minisub_main.c,1113 :: 		level = 2;
	MOV	#2, W0
	MOV	W0, _level
;minisub_main.c,1114 :: 		prev_level = level-1;
	MOV	#1, W0
	MOV	W0, _prev_level
;minisub_main.c,1117 :: 		mine_speed = 8;
	MOV	#8, W0
	MOV	W0, _mine_speed
;minisub_main.c,1120 :: 		bonus_factor = 1;
	MOV	#1, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1123 :: 		grey_mine_rate = 5;
	MOV	#5, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1112 :: 		if( (level == 1) && (score > 1000) ){
L__CheckGameLevel241:
L__CheckGameLevel240:
;minisub_main.c,1127 :: 		if( (level == 2) && (score > 2500) ){
	MOV	_level, W0
	CP	W0, #2
	BRA Z	L__CheckGameLevel376
	GOTO	L__CheckGameLevel243
L__CheckGameLevel376:
	MOV	_score, W1
	MOV	#2500, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel377
	GOTO	L__CheckGameLevel242
L__CheckGameLevel377:
L__CheckGameLevel238:
;minisub_main.c,1128 :: 		level = 3;
	MOV	#3, W0
	MOV	W0, _level
;minisub_main.c,1129 :: 		prev_level = level-1;
	MOV	#2, W0
	MOV	W0, _prev_level
;minisub_main.c,1132 :: 		mine_speed = 8;
	MOV	#8, W0
	MOV	W0, _mine_speed
;minisub_main.c,1135 :: 		bonus_factor = 1;
	MOV	#1, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1138 :: 		grey_mine_rate = 4;
	MOV	#4, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1141 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1127 :: 		if( (level == 2) && (score > 2500) ){
L__CheckGameLevel243:
L__CheckGameLevel242:
;minisub_main.c,1144 :: 		if( (level == 3) && (score > 5000) ){
	MOV	_level, W0
	CP	W0, #3
	BRA Z	L__CheckGameLevel378
	GOTO	L__CheckGameLevel245
L__CheckGameLevel378:
	MOV	_score, W1
	MOV	#5000, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel379
	GOTO	L__CheckGameLevel244
L__CheckGameLevel379:
L__CheckGameLevel237:
;minisub_main.c,1145 :: 		level = 4;
	MOV	#4, W0
	MOV	W0, _level
;minisub_main.c,1146 :: 		prev_level = level-1;
	MOV	#3, W0
	MOV	W0, _prev_level
;minisub_main.c,1149 :: 		mine_speed = 8;
	MOV	#8, W0
	MOV	W0, _mine_speed
;minisub_main.c,1152 :: 		bonus_factor = 2;
	MOV	#2, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1155 :: 		grey_mine_rate = 3;
	MOV	#3, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1158 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1144 :: 		if( (level == 3) && (score > 5000) ){
L__CheckGameLevel245:
L__CheckGameLevel244:
;minisub_main.c,1161 :: 		if( (level == 4) && (score > 8000) ){
	MOV	_level, W0
	CP	W0, #4
	BRA Z	L__CheckGameLevel380
	GOTO	L__CheckGameLevel247
L__CheckGameLevel380:
	MOV	_score, W1
	MOV	#8000, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel381
	GOTO	L__CheckGameLevel246
L__CheckGameLevel381:
L__CheckGameLevel236:
;minisub_main.c,1162 :: 		level = 5;
	MOV	#5, W0
	MOV	W0, _level
;minisub_main.c,1163 :: 		prev_level = level-1;
	MOV	#4, W0
	MOV	W0, _prev_level
;minisub_main.c,1166 :: 		mine_speed = 9;
	MOV	#9, W0
	MOV	W0, _mine_speed
;minisub_main.c,1169 :: 		bonus_factor = 3;
	MOV	#3, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1172 :: 		grey_mine_rate = 3;
	MOV	#3, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1175 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1161 :: 		if( (level == 4) && (score > 8000) ){
L__CheckGameLevel247:
L__CheckGameLevel246:
;minisub_main.c,1178 :: 		if( (level == 5) && (score > 10000) ){
	MOV	_level, W0
	CP	W0, #5
	BRA Z	L__CheckGameLevel382
	GOTO	L__CheckGameLevel249
L__CheckGameLevel382:
	MOV	_score, W1
	MOV	#10000, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel383
	GOTO	L__CheckGameLevel248
L__CheckGameLevel383:
L__CheckGameLevel235:
;minisub_main.c,1179 :: 		level = 6;
	MOV	#6, W0
	MOV	W0, _level
;minisub_main.c,1180 :: 		prev_level = level-1;
	MOV	#5, W0
	MOV	W0, _prev_level
;minisub_main.c,1183 :: 		mine_speed = 10;
	MOV	#10, W0
	MOV	W0, _mine_speed
;minisub_main.c,1186 :: 		bonus_factor = 3;
	MOV	#3, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1189 :: 		grey_mine_rate = 3;
	MOV	#3, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1192 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1178 :: 		if( (level == 5) && (score > 10000) ){
L__CheckGameLevel249:
L__CheckGameLevel248:
;minisub_main.c,1195 :: 		if( (level == 6) && (score > 12000) ){
	MOV	_level, W0
	CP	W0, #6
	BRA Z	L__CheckGameLevel384
	GOTO	L__CheckGameLevel251
L__CheckGameLevel384:
	MOV	_score, W1
	MOV	#12000, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel385
	GOTO	L__CheckGameLevel250
L__CheckGameLevel385:
L__CheckGameLevel234:
;minisub_main.c,1196 :: 		level = 7;
	MOV	#7, W0
	MOV	W0, _level
;minisub_main.c,1197 :: 		prev_level = level-1;
	MOV	#6, W0
	MOV	W0, _prev_level
;minisub_main.c,1200 :: 		mine_speed = 10;
	MOV	#10, W0
	MOV	W0, _mine_speed
;minisub_main.c,1203 :: 		bonus_factor = 3;
	MOV	#3, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1206 :: 		grey_mine_rate = 3;
	MOV	#3, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1209 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1195 :: 		if( (level == 6) && (score > 12000) ){
L__CheckGameLevel251:
L__CheckGameLevel250:
;minisub_main.c,1212 :: 		if( (level == 7) && (score > 15000) ){
	MOV	_level, W0
	CP	W0, #7
	BRA Z	L__CheckGameLevel386
	GOTO	L__CheckGameLevel253
L__CheckGameLevel386:
	MOV	_score, W1
	MOV	#15000, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel387
	GOTO	L__CheckGameLevel252
L__CheckGameLevel387:
L__CheckGameLevel233:
;minisub_main.c,1213 :: 		level = 8;
	MOV	#8, W0
	MOV	W0, _level
;minisub_main.c,1214 :: 		prev_level = level-1;
	MOV	#7, W0
	MOV	W0, _prev_level
;minisub_main.c,1217 :: 		mine_speed = 10;
	MOV	#10, W0
	MOV	W0, _mine_speed
;minisub_main.c,1220 :: 		bonus_factor = 4;
	MOV	#4, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1223 :: 		grey_mine_rate = 3;
	MOV	#3, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1226 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1212 :: 		if( (level == 7) && (score > 15000) ){
L__CheckGameLevel253:
L__CheckGameLevel252:
;minisub_main.c,1229 :: 		if( (level == 8) && (score > 15000) ){
	MOV	_level, W0
	CP	W0, #8
	BRA Z	L__CheckGameLevel388
	GOTO	L__CheckGameLevel255
L__CheckGameLevel388:
	MOV	_score, W1
	MOV	#15000, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel389
	GOTO	L__CheckGameLevel254
L__CheckGameLevel389:
L__CheckGameLevel232:
;minisub_main.c,1230 :: 		level = 9;
	MOV	#9, W0
	MOV	W0, _level
;minisub_main.c,1231 :: 		prev_level = level-1;
	MOV	#8, W0
	MOV	W0, _prev_level
;minisub_main.c,1234 :: 		mine_speed = 10;
	MOV	#10, W0
	MOV	W0, _mine_speed
;minisub_main.c,1237 :: 		bonus_factor = 3;
	MOV	#3, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1240 :: 		grey_mine_rate = 2;
	MOV	#2, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1243 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1229 :: 		if( (level == 8) && (score > 15000) ){
L__CheckGameLevel255:
L__CheckGameLevel254:
;minisub_main.c,1245 :: 		if( (level == 9) && (score > 20000) ){
	MOV	_level, W0
	CP	W0, #9
	BRA Z	L__CheckGameLevel390
	GOTO	L__CheckGameLevel257
L__CheckGameLevel390:
	MOV	_score, W1
	MOV	#20000, W0
	CP	W1, W0
	BRA GT	L__CheckGameLevel391
	GOTO	L__CheckGameLevel256
L__CheckGameLevel391:
L__CheckGameLevel231:
;minisub_main.c,1246 :: 		level = 10;
	MOV	#10, W0
	MOV	W0, _level
;minisub_main.c,1247 :: 		prev_level = level-1;
	MOV	#9, W0
	MOV	W0, _prev_level
;minisub_main.c,1250 :: 		mine_speed = 10;
	MOV	#10, W0
	MOV	W0, _mine_speed
;minisub_main.c,1253 :: 		bonus_factor = 4;
	MOV	#4, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1256 :: 		grey_mine_rate = 2;
	MOV	#2, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1259 :: 		subLives++;
	MOV	#1, W1
	MOV	#lo_addr(_subLives), W0
	ADD	W1, [W0], [W0]
;minisub_main.c,1245 :: 		if( (level == 9) && (score > 20000) ){
L__CheckGameLevel257:
L__CheckGameLevel256:
;minisub_main.c,1263 :: 		if (prev_level != level){
	MOV	_prev_level, W1
	MOV	#lo_addr(_level), W0
	CP	W1, [W0]
	BRA NZ	L__CheckGameLevel392
	GOTO	L_CheckGameLevel176
L__CheckGameLevel392:
;minisub_main.c,1265 :: 		ShowNextLevel();
	CALL	_ShowNextLevel
;minisub_main.c,1266 :: 		}
L_CheckGameLevel176:
;minisub_main.c,1270 :: 		}
L_end_CheckGameLevel:
	RETURN
; end of _CheckGameLevel

_RenderScore:

;minisub_main.c,1273 :: 		void RenderScore(){
;minisub_main.c,1278 :: 		(prev_torpedo_count != torpedo_count) ||
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	_score, W1
	MOV	#lo_addr(_prev_score), W0
	CP	W1, [W0]
	BRA Z	L__RenderScore394
	GOTO	L__RenderScore261
L__RenderScore394:
	MOV	_prev_torpedo_count, W1
	MOV	#lo_addr(_torpedo_count), W0
	CP	W1, [W0]
	BRA Z	L__RenderScore395
	GOTO	L__RenderScore260
L__RenderScore395:
;minisub_main.c,1279 :: 		(prev_subLives != subLives) ){
	MOV	_prev_subLives, W1
	MOV	#lo_addr(_subLives), W0
	CP	W1, [W0]
	BRA Z	L__RenderScore396
	GOTO	L__RenderScore259
L__RenderScore396:
	GOTO	L_RenderScore179
;minisub_main.c,1278 :: 		(prev_torpedo_count != torpedo_count) ||
L__RenderScore261:
L__RenderScore260:
;minisub_main.c,1279 :: 		(prev_subLives != subLives) ){
L__RenderScore259:
;minisub_main.c,1285 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,1288 :: 		TFT_Rectangle( 0, 0, 319, 25);
	MOV	#25, W13
	MOV	#319, W12
	CLR	W11
	CLR	W10
	CALL	_TFT_Rectangle
;minisub_main.c,1289 :: 		}
L_RenderScore179:
;minisub_main.c,1294 :: 		TFT_Image(5, 4, torpedo_bmp, 1);
	MOV	#lo_addr(_torpedo_bmp), W0
	MOV	#higher_addr(_torpedo_bmp), W1
	MOV.D	W0, W12
	MOV	#4, W11
	MOV	#5, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1297 :: 		TFT_Image(270, 2, lives_bmp, 1);
	MOV	#lo_addr(_lives_bmp), W0
	MOV	#higher_addr(_lives_bmp), W1
	MOV.D	W0, W12
	MOV	#2, W11
	MOV	#270, W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1300 :: 		IntToStr(level, level_text);
	MOV	#lo_addr(_level_text), W11
	MOV	_level, W10
	CALL	_IntToStr
;minisub_main.c,1303 :: 		IntToStr(subLives, lives_text);
	MOV	#lo_addr(_lives_text), W11
	MOV	_subLives, W10
	CALL	_IntToStr
;minisub_main.c,1306 :: 		IntToStr(torpedo_count, torpedoes_text);
	MOV	#lo_addr(_torpedoes_text), W11
	MOV	_torpedo_count, W10
	CALL	_IntToStr
;minisub_main.c,1309 :: 		IntToStr(score, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	_score, W10
	CALL	_IntToStr
;minisub_main.c,1313 :: 		TFT_Write_Text(lives_text, (270 + 20), 2);
	MOV	#2, W12
	MOV	#290, W11
	MOV	#lo_addr(_lives_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,1316 :: 		TFT_Write_Text(torpedoes_text, (5 + 35), 2);
	MOV	#2, W12
	MOV	#40, W11
	MOV	#lo_addr(_torpedoes_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,1319 :: 		TFT_Set_Font(TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#___Lib_System_DefaultPage, W0
	MOV	W0, W11
	CALL	_TFT_Set_Font
;minisub_main.c,1322 :: 		strcpy(score_display_text, "Score: ");
	MOV	#lo_addr(?lstr35_minisub_main), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcpy
;minisub_main.c,1323 :: 		strcat(score_display_text, score_text);
	MOV	#lo_addr(_score_text), W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_strcat
;minisub_main.c,1326 :: 		TFT_Write_Text(score_display_text, 120, 2);
	MOV	#2, W12
	MOV	#120, W11
	MOV	#lo_addr(_score_display_text), W10
	CALL	_TFT_Write_Text
;minisub_main.c,1327 :: 		}
L_end_RenderScore:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _RenderScore

_ClearTorpedo:

;minisub_main.c,1330 :: 		void ClearTorpedo(){
;minisub_main.c,1332 :: 		clear_torpedo.left = torpedo.x;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	MOV	_torpedo+4, W0
	MOV	W0, _clear_torpedo+2
;minisub_main.c,1333 :: 		clear_torpedo.top =  torpedo.y;
	MOV	_torpedo+6, W0
	MOV	W0, _clear_torpedo
;minisub_main.c,1334 :: 		clear_torpedo.right =  torpedo.x+torpedo.width;
	MOV	_torpedo+4, W1
	MOV	#lo_addr(_torpedo), W0
	ADD	W1, [W0], W2
	MOV	W2, _clear_torpedo+6
;minisub_main.c,1335 :: 		clear_torpedo.bottom =  torpedo.y+torpedo.height;
	MOV	_torpedo+6, W1
	MOV	#lo_addr(_torpedo+2), W0
	ADD	W1, [W0], W0
	MOV	W0, _clear_torpedo+4
;minisub_main.c,1338 :: 		TFT_Rectangle( clear_torpedo.left, clear_torpedo.top, clear_torpedo.right, clear_torpedo.bottom);
	MOV	W0, W13
	MOV	W2, W12
	MOV	_torpedo+6, W11
	MOV	_torpedo+4, W10
	CALL	_TFT_Rectangle
;minisub_main.c,1339 :: 		}
L_end_ClearTorpedo:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _ClearTorpedo

_ResetGame:

;minisub_main.c,1344 :: 		void ResetGame(){
;minisub_main.c,1347 :: 		level = 1;
	MOV	#1, W0
	MOV	W0, _level
;minisub_main.c,1348 :: 		prev_level = 1;
	MOV	#1, W0
	MOV	W0, _prev_level
;minisub_main.c,1351 :: 		score = 0;
	CLR	W0
	MOV	W0, _score
;minisub_main.c,1360 :: 		bonus_factor = 1;
	MOV	#1, W0
	MOV	W0, _bonus_factor
;minisub_main.c,1363 :: 		mine_speed = 6;
	MOV	#6, W0
	MOV	W0, _mine_speed
;minisub_main.c,1366 :: 		torpedo_count = NUMBER_OF_TORPEDOES;
	MOV	#8, W0
	MOV	W0, _torpedo_count
;minisub_main.c,1369 :: 		subLives = NUMBER_OF_SUBMARINES;
	MOV	#5, W0
	MOV	W0, _subLives
;minisub_main.c,1372 :: 		bonus_counter = 0;
	CLR	W0
	MOV	W0, _bonus_counter
;minisub_main.c,1375 :: 		grey_mine_rate = 5;
	MOV	#5, W0
	MOV	W0, _grey_mine_rate
;minisub_main.c,1378 :: 		InitSprites();
	CALL	_InitSprites
;minisub_main.c,1379 :: 		}
L_end_ResetGame:
	RETURN
; end of _ResetGame

_InitSprites:
	LNK	#2

;minisub_main.c,1381 :: 		void InitSprites(){
;minisub_main.c,1382 :: 		int mine_inc = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,1386 :: 		torpedo_count = NUMBER_OF_TORPEDOES;
	MOV	#8, W0
	MOV	W0, _torpedo_count
;minisub_main.c,1389 :: 		fire_torpedo_flag = 0;
	CLR	W0
	MOV	W0, _fire_torpedo_flag
;minisub_main.c,1393 :: 		sub.x = 28;
	MOV	#28, W0
	MOV	W0, _sub
;minisub_main.c,1394 :: 		sub.y = 128;
	MOV	#128, W0
	MOV	W0, _sub+2
;minisub_main.c,1395 :: 		sub.prev_x = sub.x;
	MOV	#28, W0
	MOV	W0, _sub+4
;minisub_main.c,1396 :: 		sub.prev_y = sub.y;
	MOV	#128, W0
	MOV	W0, _sub+6
;minisub_main.c,1400 :: 		fireball.x = 0;
	CLR	W0
	MOV	W0, _fireball+4
;minisub_main.c,1401 :: 		fireball.y = 0;
	CLR	W0
	MOV	W0, _fireball+6
;minisub_main.c,1402 :: 		fireball.prev_x = 0;
	CLR	W0
	MOV	W0, _fireball+8
;minisub_main.c,1403 :: 		fireball.prev_y = 0;
	CLR	W0
	MOV	W0, _fireball+10
;minisub_main.c,1404 :: 		fireball.width = 130;
	MOV	#130, W0
	MOV	W0, _fireball
;minisub_main.c,1405 :: 		fireball.height = 134;
	MOV	#134, W0
	MOV	W0, _fireball+2
;minisub_main.c,1409 :: 		explode.x = 0;
	CLR	W0
	MOV	W0, _explode+4
;minisub_main.c,1410 :: 		explode.y = 0;
	CLR	W0
	MOV	W0, _explode+6
;minisub_main.c,1411 :: 		explode.prev_x = 0;
	CLR	W0
	MOV	W0, _explode+8
;minisub_main.c,1412 :: 		explode.prev_y = 0;
	CLR	W0
	MOV	W0, _explode+10
;minisub_main.c,1413 :: 		explode.width = 70;
	MOV	#70, W0
	MOV	W0, _explode
;minisub_main.c,1414 :: 		explode.height = 60;
	MOV	#60, W0
	MOV	W0, _explode+2
;minisub_main.c,1417 :: 		torpedo.x = 0;
	CLR	W0
	MOV	W0, _torpedo+4
;minisub_main.c,1418 :: 		torpedo.y = 0;
	CLR	W0
	MOV	W0, _torpedo+6
;minisub_main.c,1419 :: 		torpedo.prev_x = 0;
	CLR	W0
	MOV	W0, _torpedo+8
;minisub_main.c,1420 :: 		torpedo.prev_y = 0;
	CLR	W0
	MOV	W0, _torpedo+10
;minisub_main.c,1421 :: 		torpedo.visible = 1;
	MOV	#1, W0
	MOV	W0, _torpedo+12
;minisub_main.c,1422 :: 		torpedo.width = 35;
	MOV	#35, W0
	MOV	W0, _torpedo
;minisub_main.c,1423 :: 		torpedo.height = 14;
	MOV	#14, W0
	MOV	W0, _torpedo+2
;minisub_main.c,1426 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 12 (W6)
	CLR	W6
; mine_inc end address is: 12 (W6)
L_InitSprites180:
; mine_inc start address is: 12 (W6)
	CP	W6, #3
	BRA LE	L__InitSprites400
	GOTO	L_InitSprites181
L__InitSprites400:
;minisub_main.c,1427 :: 		mine[mine_inc].x = (mine_inc * 90) + 200;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #4, W1
	MOV	#90, W0
	MUL.SS	W6, W0, W2
	MOV	#200, W0
	ADD	W2, W0, W0
	MOV	W0, [W1]
;minisub_main.c,1428 :: 		mine[mine_inc].y = RandomHeightY();
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W0
	MOV	W0, [W14+0]
	CALL	_RandomHeightY
	MOV	[W14+0], W1
	MOV	W0, [W1]
;minisub_main.c,1430 :: 		mine[mine_inc].prev_x = mine[mine_inc].x ;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W1
	ADD	W0, #4, W0
	MOV	[W0], [W1]
;minisub_main.c,1431 :: 		mine[mine_inc].prev_y = mine[mine_inc].y ;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W1
	ADD	W0, #6, W0
	MOV	[W0], [W1]
;minisub_main.c,1432 :: 		mine[mine_inc].width = 45;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W1
	MOV	#45, W0
	MOV	W0, [W1]
;minisub_main.c,1433 :: 		mine[mine_inc].height = 45;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #2, W1
	MOV	#45, W0
	MOV	W0, [W1]
;minisub_main.c,1436 :: 		mine[mine_inc].type = RandomSeaMineType();
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W0
	MOV	W0, [W14+0]
	CALL	_RandomSeaMineType
	MOV	[W14+0], W1
	MOV	W0, [W1]
;minisub_main.c,1442 :: 		mine[mine_inc].hits = 0;
	MOV	#18, W0
	MUL.UU	W0, W6, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #16, W1
	CLR	W0
	MOV	W0, [W1]
;minisub_main.c,1426 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W6
;minisub_main.c,1443 :: 		}
; mine_inc end address is: 12 (W6)
	GOTO	L_InitSprites180
L_InitSprites181:
;minisub_main.c,1448 :: 		bonus_block.x = SCREEN_WIDTH*BONUS_SCREEN_SPACING;
	MOV	#640, W0
	MOV	W0, _bonus_block+4
;minisub_main.c,1449 :: 		bonus_block.y = RandomHeightY();  //generate random block Y position
	CALL	_RandomHeightY
	MOV	W0, _bonus_block+6
;minisub_main.c,1450 :: 		bonus_block.prev_x = 0;
	CLR	W0
	MOV	W0, _bonus_block+8
;minisub_main.c,1451 :: 		bonus_block.prev_y = 0;
	CLR	W0
	MOV	W0, _bonus_block+10
;minisub_main.c,1452 :: 		bonus_block.visible = 1;
	MOV	#1, W0
	MOV	W0, _bonus_block+12
;minisub_main.c,1453 :: 		bonus_block.width = 45;
	MOV	#45, W0
	MOV	W0, _bonus_block
;minisub_main.c,1454 :: 		bonus_block.height = 45;
	MOV	#45, W0
	MOV	W0, _bonus_block+2
;minisub_main.c,1457 :: 		bonus_type = 1;
	MOV	#1, W0
	MOV	W0, _bonus_type
;minisub_main.c,1460 :: 		TFT_Set_Pen(bgColor, 1);
	MOV	#1, W11
	MOV	_bgColor, W10
	CALL	_TFT_Set_Pen
;minisub_main.c,1463 :: 		TFT_Set_Brush(1, bgColor, 0, TOP_TO_BOTTOM, CL_BLACK, CL_BLACK);
	CLR	W13
	CLR	W12
	MOV	_bgColor, W11
	MOV	#1, W10
	CLR	W0
	PUSH	W0
	CLR	W0
	PUSH	W0
	CALL	_TFT_Set_Brush
	SUB	#4, W15
;minisub_main.c,1466 :: 		TFT_Fill_Screen(bgColor);
	MOV	_bgColor, W10
	CALL	_TFT_Fill_Screen
;minisub_main.c,1468 :: 		}
L_end_InitSprites:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _InitSprites

_SavePreviousVal:

;minisub_main.c,1471 :: 		void SavePreviousVal(){
;minisub_main.c,1472 :: 		int mine_inc = 0;
;minisub_main.c,1475 :: 		prev_score = score;
	MOV	_score, W0
	MOV	W0, _prev_score
;minisub_main.c,1478 :: 		sub.prev_x = sub.x;
	MOV	_sub, W0
	MOV	W0, _sub+4
;minisub_main.c,1479 :: 		sub.prev_y = sub.y;
	MOV	_sub+2, W0
	MOV	W0, _sub+6
;minisub_main.c,1482 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
; mine_inc start address is: 8 (W4)
	CLR	W4
; mine_inc end address is: 8 (W4)
L_SavePreviousVal183:
; mine_inc start address is: 8 (W4)
	CP	W4, #3
	BRA LE	L__SavePreviousVal402
	GOTO	L_SavePreviousVal184
L__SavePreviousVal402:
;minisub_main.c,1483 :: 		mine[mine_inc].prev_x = mine[mine_inc].x;
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #8, W1
	ADD	W0, #4, W0
	MOV	[W0], [W1]
;minisub_main.c,1484 :: 		mine[mine_inc].prev_y = mine[mine_inc].y;
	MOV	#18, W0
	MUL.UU	W0, W4, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #10, W1
	ADD	W0, #6, W0
	MOV	[W0], [W1]
;minisub_main.c,1482 :: 		for(mine_inc = 0; mine_inc <= (NUMBER_OF_SEA_MINES-1); mine_inc++){
	INC	W4
;minisub_main.c,1485 :: 		}
; mine_inc end address is: 8 (W4)
	GOTO	L_SavePreviousVal183
L_SavePreviousVal184:
;minisub_main.c,1488 :: 		torpedo.prev_x = torpedo.x;
	MOV	_torpedo+4, W0
	MOV	W0, _torpedo+8
;minisub_main.c,1489 :: 		torpedo.prev_y = torpedo.y;
	MOV	_torpedo+6, W0
	MOV	W0, _torpedo+10
;minisub_main.c,1492 :: 		bonus_block.prev_x = bonus_block.x;
	MOV	_bonus_block+4, W0
	MOV	W0, _bonus_block+8
;minisub_main.c,1493 :: 		bonus_block.prev_y = bonus_block.y;
	MOV	_bonus_block+6, W0
	MOV	W0, _bonus_block+10
;minisub_main.c,1496 :: 		prev_torpedo_count = torpedo_count;
	MOV	_torpedo_count, W0
	MOV	W0, _prev_torpedo_count
;minisub_main.c,1497 :: 		prev_subLives = subLives;
	MOV	_subLives, W0
	MOV	W0, _prev_subLives
;minisub_main.c,1500 :: 		destroyed_mine_id = -1;
	MOV	#65535, W0
	MOV	W0, _destroyed_mine_id
;minisub_main.c,1503 :: 		bonus_id = -1;
	MOV	#65535, W0
	MOV	W0, _bonus_id
;minisub_main.c,1506 :: 		prev_level = level;
	MOV	_level, W0
	MOV	W0, _prev_level
;minisub_main.c,1508 :: 		}
L_end_SavePreviousVal:
	RETURN
; end of _SavePreviousVal

_IsCollision:
	LNK	#0

;minisub_main.c,1513 :: 		unsigned int Bomb_Left, unsigned int Bomb_Top, unsigned int Bomb_Width, unsigned int Bomb_Height) {
;minisub_main.c,1517 :: 		if( ((Shape_X + Shape_Width) >= Bomb_Left )               &&              ((Shape_X) <= (Bomb_Left + Bomb_Width-1)) &&
; Bomb_Left start address is: 2 (W1)
	MOV	[W14-8], W1
; Bomb_Top start address is: 4 (W2)
	MOV	[W14-10], W2
; Bomb_Width start address is: 6 (W3)
	MOV	[W14-12], W3
; Bomb_Height start address is: 8 (W4)
	MOV	[W14-14], W4
	ADD	W10, W12, W0
	CP	W0, W1
	BRA GEU	L__IsCollision404
	GOTO	L__IsCollision230
L__IsCollision404:
	ADD	W1, W3, W0
; Bomb_Left end address is: 2 (W1)
; Bomb_Width end address is: 6 (W3)
	DEC	W0
	CP	W10, W0
	BRA LEU	L__IsCollision405
	GOTO	L__IsCollision229
L__IsCollision405:
;minisub_main.c,1522 :: 		((Shape_Y + Shape_Height) >= Bomb_Top )                   &&               ((Shape_Y) <= (Bomb_Top + Bomb_Height-1))  ) {
	ADD	W11, W13, W0
	CP	W0, W2
	BRA GEU	L__IsCollision406
	GOTO	L__IsCollision228
L__IsCollision406:
	ADD	W2, W4, W0
; Bomb_Top end address is: 4 (W2)
; Bomb_Height end address is: 8 (W4)
	DEC	W0
	CP	W11, W0
	BRA LEU	L__IsCollision407
	GOTO	L__IsCollision227
L__IsCollision407:
L__IsCollision226:
;minisub_main.c,1529 :: 		return 1;
	MOV.B	#1, W0
	GOTO	L_end_IsCollision
;minisub_main.c,1517 :: 		if( ((Shape_X + Shape_Width) >= Bomb_Left )               &&              ((Shape_X) <= (Bomb_Left + Bomb_Width-1)) &&
L__IsCollision230:
L__IsCollision229:
;minisub_main.c,1522 :: 		((Shape_Y + Shape_Height) >= Bomb_Top )                   &&               ((Shape_Y) <= (Bomb_Top + Bomb_Height-1))  ) {
L__IsCollision228:
L__IsCollision227:
;minisub_main.c,1535 :: 		return 0;
	CLR	W0
;minisub_main.c,1538 :: 		}
L_end_IsCollision:
	ULNK
	RETURN
; end of _IsCollision

_GetNextSong:

;minisub_main.c,1542 :: 		void GetNextSong(){
;minisub_main.c,1543 :: 		UART2_Write_Line("Switching to the next song.");
	PUSH	W10
	MOV	#lo_addr(?lstr36_minisub_main), W10
	CALL	_UART2_Write_Line
;minisub_main.c,1545 :: 		Load_MP3_File("Pavese.mp3");
	MOV	#lo_addr(?lstr37_minisub_main), W10
	CALL	_Load_MP3_File
;minisub_main.c,1548 :: 		if(current_pos < 10){
	MOV	_current_pos, W0
	MOV	_current_pos+2, W1
	CP	W0, #10
	CPB	W1, #0
	BRA LT	L__GetNextSong409
	GOTO	L_GetNextSong190
L__GetNextSong409:
;minisub_main.c,1549 :: 		PreRollSong();
	CALL	_PreRollSong
;minisub_main.c,1550 :: 		}
L_GetNextSong190:
;minisub_main.c,1552 :: 		}
L_end_GetNextSong:
	POP	W10
	RETURN
; end of _GetNextSong

_PreRollSong:
	LNK	#4

;minisub_main.c,1555 :: 		void PreRollSong(){
;minisub_main.c,1556 :: 		int roll = 0;
;minisub_main.c,1557 :: 		int roll_max = 120;   //100
	MOV	#120, W0
	MOV	W0, [W14+2]
;minisub_main.c,1560 :: 		for(roll = 0; roll<=roll_max;roll++){
	CLR	W0
	MOV	W0, [W14+0]
L_PreRollSong191:
	MOV	[W14+0], W1
	ADD	W14, #2, W0
	CP	W1, [W0]
	BRA LE	L__PreRollSong411
	GOTO	L_PreRollSong192
L__PreRollSong411:
;minisub_main.c,1561 :: 		Play_MP3_Chunk();
	CALL	_Play_MP3_Chunk
;minisub_main.c,1560 :: 		for(roll = 0; roll<=roll_max;roll++){
	MOV	[W14+0], W1
	ADD	W14, #0, W0
	ADD	W1, #1, [W0]
;minisub_main.c,1562 :: 		}
	GOTO	L_PreRollSong191
L_PreRollSong192:
;minisub_main.c,1563 :: 		}
L_end_PreRollSong:
	ULNK
	RETURN
; end of _PreRollSong

_AnimateSeaMine:

;minisub_main.c,1567 :: 		void AnimateSeaMine(int mineNum){
;minisub_main.c,1568 :: 		unsigned long the_frame = 0;
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
;minisub_main.c,1571 :: 		the_frame = (frame_counter + mineNum) % 6;
	MOV	W10, W3
	ASR	W3, #15, W4
	MOV	#lo_addr(_frame_counter), W2
	ADD	W3, [W2++], W0
	ADDC	W4, [W2--], W1
	PUSH	W10
	MOV	#6, W2
	MOV	#0, W3
	CLR	W4
	CALL	__Modulus_32x32
	POP	W10
; the_frame start address is: 8 (W4)
	MOV.D	W0, W4
;minisub_main.c,1575 :: 		if(mine[mineNum].type == 0) {
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #14, W0
	MOV	[W0], W0
	CP	W0, #0
	BRA Z	L__AnimateSeaMine413
	GOTO	L_AnimateSeaMine194
L__AnimateSeaMine413:
;minisub_main.c,1578 :: 		switch (the_frame) {
	GOTO	L_AnimateSeaMine195
; the_frame end address is: 8 (W4)
;minisub_main.c,1579 :: 		case 0 :
L_AnimateSeaMine197:
;minisub_main.c,1580 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, mine6_bmp, 1);
	MOV	#lo_addr(_mine6_bmp), W4
	MOV	#higher_addr(_mine6_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1581 :: 		break;
	GOTO	L_AnimateSeaMine196
;minisub_main.c,1583 :: 		case 1 :
L_AnimateSeaMine198:
;minisub_main.c,1584 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, mine5_bmp, 1);
	MOV	#lo_addr(_mine5_bmp), W4
	MOV	#higher_addr(_mine5_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1585 :: 		break;
	GOTO	L_AnimateSeaMine196
;minisub_main.c,1587 :: 		case 2 :
L_AnimateSeaMine199:
;minisub_main.c,1588 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, mine4_bmp, 1);
	MOV	#lo_addr(_mine4_bmp), W4
	MOV	#higher_addr(_mine4_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1589 :: 		break;
	GOTO	L_AnimateSeaMine196
;minisub_main.c,1591 :: 		case 3 :
L_AnimateSeaMine200:
;minisub_main.c,1592 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, mine3_bmp, 1);
	MOV	#lo_addr(_mine3_bmp), W4
	MOV	#higher_addr(_mine3_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1593 :: 		break;
	GOTO	L_AnimateSeaMine196
;minisub_main.c,1595 :: 		case 4 :
L_AnimateSeaMine201:
;minisub_main.c,1596 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, mine2_bmp, 1);
	MOV	#lo_addr(_mine2_bmp), W4
	MOV	#higher_addr(_mine2_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1597 :: 		break;
	GOTO	L_AnimateSeaMine196
;minisub_main.c,1599 :: 		case 5 :
L_AnimateSeaMine202:
;minisub_main.c,1600 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, mine1_bmp, 1);
	MOV	#lo_addr(_mine1_bmp), W4
	MOV	#higher_addr(_mine1_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1601 :: 		break;
	GOTO	L_AnimateSeaMine196
;minisub_main.c,1603 :: 		default:
L_AnimateSeaMine203:
;minisub_main.c,1604 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, mine1_bmp, 1);
	MOV	#lo_addr(_mine1_bmp), W4
	MOV	#higher_addr(_mine1_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1605 :: 		break;
	GOTO	L_AnimateSeaMine196
;minisub_main.c,1606 :: 		}
L_AnimateSeaMine195:
; the_frame start address is: 8 (W4)
	CP	W4, #0
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine414
	GOTO	L_AnimateSeaMine197
L__AnimateSeaMine414:
	CP	W4, #1
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine415
	GOTO	L_AnimateSeaMine198
L__AnimateSeaMine415:
	CP	W4, #2
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine416
	GOTO	L_AnimateSeaMine199
L__AnimateSeaMine416:
	CP	W4, #3
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine417
	GOTO	L_AnimateSeaMine200
L__AnimateSeaMine417:
	CP	W4, #4
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine418
	GOTO	L_AnimateSeaMine201
L__AnimateSeaMine418:
	CP	W4, #5
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine419
	GOTO	L_AnimateSeaMine202
L__AnimateSeaMine419:
; the_frame end address is: 8 (W4)
	GOTO	L_AnimateSeaMine203
L_AnimateSeaMine196:
;minisub_main.c,1608 :: 		}
	GOTO	L_AnimateSeaMine204
L_AnimateSeaMine194:
;minisub_main.c,1612 :: 		switch (the_frame) {
; the_frame start address is: 8 (W4)
	GOTO	L_AnimateSeaMine205
; the_frame end address is: 8 (W4)
;minisub_main.c,1613 :: 		case 0 :
L_AnimateSeaMine207:
;minisub_main.c,1614 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, dark_mine6_bmp, 1);
	MOV	#lo_addr(_dark_mine6_bmp), W4
	MOV	#higher_addr(_dark_mine6_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1615 :: 		break;
	GOTO	L_AnimateSeaMine206
;minisub_main.c,1617 :: 		case 1 :
L_AnimateSeaMine208:
;minisub_main.c,1618 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, dark_mine5_bmp, 1);
	MOV	#lo_addr(_dark_mine5_bmp), W4
	MOV	#higher_addr(_dark_mine5_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1619 :: 		break;
	GOTO	L_AnimateSeaMine206
;minisub_main.c,1621 :: 		case 2 :
L_AnimateSeaMine209:
;minisub_main.c,1622 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, dark_mine4_bmp, 1);
	MOV	#lo_addr(_dark_mine4_bmp), W4
	MOV	#higher_addr(_dark_mine4_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1623 :: 		break;
	GOTO	L_AnimateSeaMine206
;minisub_main.c,1625 :: 		case 3 :
L_AnimateSeaMine210:
;minisub_main.c,1626 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, dark_mine3_bmp, 1);
	MOV	#lo_addr(_dark_mine3_bmp), W4
	MOV	#higher_addr(_dark_mine3_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1627 :: 		break;
	GOTO	L_AnimateSeaMine206
;minisub_main.c,1629 :: 		case 4 :
L_AnimateSeaMine211:
;minisub_main.c,1630 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, dark_mine2_bmp, 1);
	MOV	#lo_addr(_dark_mine2_bmp), W4
	MOV	#higher_addr(_dark_mine2_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1631 :: 		break;
	GOTO	L_AnimateSeaMine206
;minisub_main.c,1633 :: 		case 5 :
L_AnimateSeaMine212:
;minisub_main.c,1634 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, dark_mine1_bmp, 1);
	MOV	#lo_addr(_dark_mine1_bmp), W4
	MOV	#higher_addr(_dark_mine1_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1635 :: 		break;
	GOTO	L_AnimateSeaMine206
;minisub_main.c,1637 :: 		default:
L_AnimateSeaMine213:
;minisub_main.c,1638 :: 		TFT_Image(mine[mineNum].x, mine[mineNum].y, dark_mine1_bmp, 1);
	MOV	#lo_addr(_dark_mine1_bmp), W4
	MOV	#higher_addr(_dark_mine1_bmp), W5
	MOV	#18, W0
	MUL.UU	W0, W10, W2
	MOV	#lo_addr(_mine), W0
	ADD	W0, W2, W0
	ADD	W0, #6, W1
	ADD	W0, #4, W0
	MOV.D	W4, W12
	MOV	[W1], W11
	MOV	[W0], W10
	MOV	#1, W0
	PUSH	W0
	CALL	_TFT_Image
	SUB	#2, W15
;minisub_main.c,1639 :: 		break;
	GOTO	L_AnimateSeaMine206
;minisub_main.c,1640 :: 		}
L_AnimateSeaMine205:
; the_frame start address is: 8 (W4)
	CP	W4, #0
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine420
	GOTO	L_AnimateSeaMine207
L__AnimateSeaMine420:
	CP	W4, #1
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine421
	GOTO	L_AnimateSeaMine208
L__AnimateSeaMine421:
	CP	W4, #2
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine422
	GOTO	L_AnimateSeaMine209
L__AnimateSeaMine422:
	CP	W4, #3
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine423
	GOTO	L_AnimateSeaMine210
L__AnimateSeaMine423:
	CP	W4, #4
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine424
	GOTO	L_AnimateSeaMine211
L__AnimateSeaMine424:
	CP	W4, #5
	CPB	W5, #0
	BRA NZ	L__AnimateSeaMine425
	GOTO	L_AnimateSeaMine212
L__AnimateSeaMine425:
; the_frame end address is: 8 (W4)
	GOTO	L_AnimateSeaMine213
L_AnimateSeaMine206:
;minisub_main.c,1642 :: 		}
L_AnimateSeaMine204:
;minisub_main.c,1646 :: 		}
L_end_AnimateSeaMine:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	RETURN
; end of _AnimateSeaMine
